/*	cbignuma.cpp

	 ᫠  ࠭祭 ࠧ來 ⪮.
	㦥 㭪樨  ᥬ୮ ਠ.

	(C) ..஢,   PAH, 1999 - 2000
	All Rights Reserved.
*/
//#include <ctype.h>
//#include <stdlib.h>
#include <iomanip.h>
#include <limits.h>
#include "cbignum.h"

#define	BITS		(CHAR_BIT * sizeof (long))

//	ᯮ짮 ᥬ Intel 386.
//	 ࠡ⠥ ⮫쪮  ࠭
//	Borland C++ 4.5  32-ࠧ來 ०.

#if sizeof(int)==4
#define	_CBIGNUM_ASM
#ifdef	__BORLANDC__
#pragma inline
#endif
#endif

//	㭪樨, ॠ  ⠭⭮ ++.

#include "cbignumf.cpp"

//	ᥬ ਠ  㭪権  cbignumf.cpp
//	ࠢ  ਬ ᠭ  䠩 BigNumF.cpp
	
#ifdef	_CBIGNUM_ASM

#ifdef	NCHECKPTR
extern "C"
{
#endif//NCHECKPTR

size_t	_cBigNumberMSubD (			// ⠭ p1 -= p2<<k2*BITS
			long*  p1,		// ⠥.
		const	long*  p2,		// ⥫ ࠧ  n1-k2.
			size_t k2		//  ⥫ .
	)					// p1  p2  ᮢ.
{
  size_t n2 = (size_t)(*p2);			// ᫮ ᫮ p2.

//	ᥬ ਠ  Intel 386  ࠡ⪮ 8 ᫮   横.
//	 ࠡ ᫮  2.25 ⠪.

  {
    p1 += k2;					// 砫 ⠭  p1.
    p1 += _cBigNumberMSubD_skip;		// ४ 砫 p1.
    p2 += _cBigNumberMSubD_skip;		// ४ 砫 p2.
    _EBX = _ESI = n2 -_cBigNumberMSubD_skip + 1;// ᫮ ⠥ ᫮.
    _EBX >>= 3;					// ᫮ 室.
    _EDI = *p2;		_EAX = *p1;		// 㧪 ॣ஢.
    if ((_ESI &= 7) != 0)			// 㤥   室.
    {
      ++_EBX;
      if (--_ESI == 0) { p1 -= 7; p2 -= 7; __asm clc; goto go1; }
      if (--_ESI == 0) { p1 -= 6; p2 -= 6; __asm clc; goto go2; }
      if (--_ESI == 0) { p1 -= 5; p2 -= 5; __asm clc; goto go3; }
      if (--_ESI == 0) { p1 -= 4; p2 -= 4; __asm clc; goto go4; }
      if (--_ESI == 0) { p1 -= 3; p2 -= 3; __asm clc; goto go5; }
      if (--_ESI == 0) { p1 -= 2; p2 -= 2; __asm clc; goto go6; }
		         p1 -= 1; p2 -= 1; __asm clc; goto go7;
    }
      __asm clc;			 	//  室 - .
    do
    {
      __asm sbb eax, edi;	_EDI = p2 [1];	// ⠭  .
      p1 [0] = _EAX;		_EAX = p1 [1];	// /㧪 p1.
go7:  __asm sbb eax, edi;	_EDI = p2 [2];	// ⠭  .
      p1 [1] = _EAX;		_EAX = p1 [2];	// /㧪 p1.
go6:  __asm sbb eax, edi;	_EDI = p2 [3];	// ⠭  .
      p1 [2] = _EAX;		_EAX = p1 [3];	// /㧪 p1.
go5:  __asm sbb eax, edi;	_EDI = p2 [4];	// ⠭  .
      p1 [3] = _EAX;		_EAX = p1 [4];	// /㧪 p1.
go4:  __asm sbb eax, edi;	_EDI = p2 [5];	// ⠭  .
      p1 [4] = _EAX;		_EAX = p1 [5];	// /㧪 p1.
go3:  __asm sbb eax, edi;	_EDI = p2 [6];	// ⠭  .
      p1 [5] = _EAX;		_EAX = p1 [6];	// /㧪 p1.
go2:  __asm sbb eax, edi;	_EDI = p2 [7];	// ⠭  .
      p1 [6] = _EAX;		_EAX = p1 [7];	// /㧪 p1.
go1:  __asm sbb eax, edi;	_EDI = p2 [8];	// ⠭  .
      p1 [7] = _EAX;		_EAX = p1 [8];	// /㧪 p1.

#ifdef	__BORLANDC__
//    __asm lea p1 p1[8]; __asm lea p2 p2[8];	// p1  p2 -  _EDX  _ECX.
      __asm db 8DH,52H,20H,8DH,49H,20H;		// ⮢  権 lea
#else
      __asm sbb esi, esi;
      p1 += 8;		p2 += 8;
      __asm shr esi, 1;
#endif      

    }
    while ((--_EBX) != 0);			//  横  p1  p2.
  }

//	ଠ - 㤠 譨  ᫮ p,   0  1
//	 ᮢ  ७  ࠧ鸞 ।饣 ᫮.
//	।-᫮: p1 㪠뢠  ᫮, ᫥饥  ᫥ 祭.
  {
    register long pass = p1 [-1];		// ᫥ ᫮.
    register size_t n1 = n2 + k2;

//	 横 믮 樨:
//	do continue;
//	while (--n1 != 0 && 
//		lp1==(lp1 = pass, pass = p1[-2], --p1, pass>>(BITS-1)));

    for (;;)
    {
      register long lp1;			// 襥 ᫮.
      register long lp2;			// ।饥 ᫮.
      if (--n1 == 0)	break;			// ⠫  ᫮.
      lp2 = p1[-2];	--p1;
      lp1 = pass;	pass = lp2;
      lp2 >>= BITS-1;
      if (lp1 != lp2)	break;
    }
    return (n1 + 1);				// 뤠 ᫮ ᫮ p.
  }
}

#ifdef	NCHECKPTR
}
#else

//	室  ⫠筮 ०.

extern "C"
{

size_t	_cBigNumberMSubD (			// ⠭ p1 -= p2<<k2*BITS
			EXPTR(long) p1,		// ⠥.
		const	EXPTR(long) p2,		// ⥫ ࠧ  n1-k2.
			size_t k2		//  ⥫ .
	)					// p1  p2  ᮢ.
{
  size_t n1 = (size_t)(*p1);			// ᫮ ᫮ p2.
  size_t n2 = (size_t)(*p2);			// ᫮ ᫮ p2.
  assert (n1 >= n2 + k2);			// ஢ઠ ࠧ.
  assert (n2 > 0);				// ஢ઠ ࠧ.
  p1 [n1];					// ஢ઠ .
  p2 [n2];					// ஢ઠ .

  return _cBigNumberMSubD (p1.base(), p2.base(), k2);
}

}
#endif//NCHECKPTR

#endif//_CBIGNUM_ASM
