/*	doswin.c

	 䠩: ४஢ DOS<->WIN

	(C) ..஢,   PAH, 1999
	All Rights Reserved.
*/
#include <exio.h>

//     
//     
//		    0x8,  0x9,  0xA,  0xB,  0xC,  0xD,  0xE,  0xF

char _dos2win[] = { (char)0x00, (char)0x10, (char)0x20, (char)0x30,
		    (char)0x40, (char)0x50, (char)0x60, (char)0x70,
		    (char)0xC0, (char)0xD0, (char)0xE0, (char)0x80, 
		    (char)0x90, (char)0xA0, (char)0xF0, (char)0xB0 };

char _win2dos[] = { (char)0x00, (char)0x10, (char)0x20, (char)0x30,
		    (char)0x40, (char)0x50, (char)0x60, (char)0x70,
                    (char)0xB0, (char)0xC0, (char)0xD0, (char)0xF0,
		    (char)0x80, (char)0x90, (char)0xA0, (char)0xE0 };

char*   dos2win		(char *psz)     // ४஢ DOS->WIN
{
  register char *ps;
  for (ps = psz; *ps; ps++)
//if ((signed char)*ps < 0)		// ⨬  ᪮.
  {
    if (*ps == (char) 240) *ps = (char) 168 ; else	// 
    if (*ps == (char) 241) *ps = (char) 184 ; else     // 
    *ps = (char)
	(_dos2win [((unsigned char)*ps) >> 4] | ((unsigned char)*ps & 0xF));
  }
  return (psz);
}

char*   win2dos		(char *psz)     // ४஢ WIN->DOS.
{
  register char *ps;
  for (ps = psz; *ps; ps++)
//if ((signed char)*ps < 0)		// ⨬  ᪮.
  {
    if (*ps == (char) 168) *ps = (char) 240; else	// 
    if (*ps == (char) 184) *ps = (char) 241; else	// 
    *ps = (char)
	(_win2dos [((unsigned char)*ps) >> 4] | ((unsigned char)*ps & 0xF));
  }
  return (psz);
}
