/*	exreloc.c

	।   ࠡ⪮ 訡.

	(C) ..஢,   PAH, 1994 - 2000
	All Rights Reserved.
*/
//#define EXTRACE
#include <malloc.h>
#include <memory.h>
#include <exalloc.h>
#include <exhandle.h>

void	STDECL	exmrealloc (	// ।   㫥.
	void**	p,		// ⥫   NULL.
	size_t	blocksize,	//  ࠧ.
	size_t	memset_start,	// 砫  㫥,
	size_t	memset_stop	//   㫥,
	)			// 뤠 0  㤠.
{
#ifdef	EXTRACE
  exprintf("exmrealloc(%p,%10u,%10u,%10u)=",
	*p, blocksize, memset_start, memset_stop);
#endif
  void* pp = *p;
  if (blocksize)					// 뤥 .
  {
    errno = 0;
    while (blocksize > EXCALCBLOCKSIZE_MAX 
       || (pp = realloc (*p, blocksize)) == NULL)	// 饭.
    {                                      		// 訡 ࠧ饭.
      _exalloc_blocksize = blocksize;
      if (exalloc_fail_handle() == 0) return;
    }
    if (memset_stop > memset_start)			// 㫥 .
       memset ((char*)pp + memset_start, 0,
	     memset_stop - memset_start);
  }
  else if (pp)						// c .
  { 
    free (pp); pp = NULL;
  }
  *p = pp;
#ifdef	EXTRACE
  exprintf("%p, coreleft=%lu\n", *p, (unsigned long) excoreleft());
#endif
}
