/*	exarray.cpp

	᪨ ᨢ  ⮬᪮ ஢મ .
	㭪樨 ।   ࠡ⪨ 訡.
	http://www.imach.uran.ru/exarray

	(C) ..஢,   PAH, 1998 - 2000
	All Rights Reserved.
*/
//#define EXTRACE
#ifdef	EXTRACE
#include <fstream.h>
#include <iomanip.h>
#endif
#include <malloc.h>
#include <memory.h>
#include <stdlib.h>
#include <new.h>
#include "exarray.h"

#ifdef __cplusplus
extern "C" {
#endif

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	訡 । .
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.
//	᫨ 㪠⥫ ࠢ NULL,  ࠡ⪠
//	믮 㭪樥, ⠭
//	 set_new_handler  new.h, ᫨ 
//	 ⠪ ,  뢠 abort().

void	(* VDECL _exalloc_fail_handler)(void) = abort;

//------------------------------------------------
//	ଠ  । .
//	ਬ  業 ꥬ
//	ᯮ짮 .

char*	VDECL	_expmin;	//   㪠⥫.
char*	VDECL	_expmax;	// ᨬ 㪠⥫.

//------------------------------------------------
//	㭪 exmalloc 뤥  ,
//	 ﬨ.
//
//	㭪 exmrealloc 뤥, 㤫,
//	㪮稢  ᢮  ,
//	 㫥  ⪠.
//
//	     .
//	 ९ ࠧ來 ⪨ 
//	 墠⪥  뢠 㭪,
//	᢮ _exalloc_fail_handler.
//	᫨ _exalloc_fail_handler == NULL,
//	 뢠 㭪, ⠭
//	 set_new_handler  new.h, ᫨ 
//	 ⠪ ,  뢠 abort().
//
//	㭪 exfree ᢮  .

void*	STDECL	exmalloc (size_t blocksize)
{
  void* p = NULL;
  exmrealloc (&p, blocksize, 0, blocksize);
  return (p);
}

void	STDECL	exmrealloc (
	void** p,		// ⥫   NULL.
	size_t blocksize,	//  ࠧ.
	size_t memset_start,	// 砫  㫥,
	size_t memset_stop)	//   㫥,
{				//   㪠 .
#ifdef	EXTRACE
  cout<<"exmrealloc("<< *p 
	<<","<< setw(4) << blocksize
	<<","<< setw(4) << memset_start 
	<<","<< setw(4) << memset_stop <<")=";
//TRACE("exmrealloc(%p,%d,%d,%d)=",*p,blocksize,memset_start,memset_stop);
#endif
  void* pp = *p;
  if (blocksize)		// 뤥 .
  {
    while (blocksize > EXCALCBLOCKSIZE_MAX
       || (pp = realloc (*p, blocksize)) == NULL)
    {				// 訡 ।.
      if (_exalloc_fail_handler != NULL)
      {
	(*_exalloc_fail_handler)(); return;
      }
      {
        typedef void (*pvfunc) (void);
        pvfunc pvf = set_new_handler (NULL);
        set_new_handler (pvf);
        if (pvf != NULL) (*pvf)(); else abort();
      }
    }
				// 㫥.
    if (memset_stop > memset_start)
       memset ((char*)pp + memset_start, 0,
	     memset_stop - memset_start);
				//  ⪠.
    if (_expmin == NULL || _expmin > pp)
        _expmin = (char*)pp;
    if (_expmax < (char*)pp + blocksize)
        _expmax = (char*)pp + blocksize;
  }
  else if (pp)			// c .
  { 
    free (pp); pp = NULL;
  }
  *p = pp;
#ifdef	EXTRACE
  cout	<< pp <<"\n";
//TRACE("%d\n",pp);
#endif
}

void	STDECL	exfree (void* p)
{
#ifdef	EXTRACE
  exmrealloc (&p, 0, 0, 0);  
#else
  if (p) free (p);
#endif
}  

//------------------------------------------------
//	㭪 excalcblocksize 뢠
//	ࠧ    , 
//	    ॡ㥬. 
//
//	砫 ࠧ EXCALCBLOCKSIZE_MOD
//	। 㬭  2  1.5, 
//	⠭  襭. 祭
//	EXCALCBLOCKSIZE_MOD   exarray.h
//	 64**n +/- 16, ⮬ १
//	 㤥 ⭠ 16  32,   64.
//	᫥ ⢥  ⨬樨 
//	㧪  L1  Pentium 
//	饭  ࠧ  
//	  ᬥ饭,  ⢥ঠ
//	⠬ - . exarray.prt.
//
//	 㬥襭 ࠣ樨 ᪮
//	   뢠 ࠧ
//	⥬  EXCALCBLOCKSIZE_SYS,
//	塞 㭪樥 realloc 
//	Borland C++ 3.1, 4.5.
//
//	᫨ 襭 ࠧ ᫨誮 ,
//	 뤠 EXSIZE_T_MAX.

size_t	STDECL	excalcblocksize (size_t blocksize)
{
  size_t n = EXCALCBLOCKSIZE_MOD, k = 0;
  for (;; k = ~k, (k? (n <<= 1): (n += (n >> 1))))
  {
    n -= EXCALCBLOCKSIZE_SYS; if (n >= blocksize) break;
    n += EXCALCBLOCKSIZE_SYS; if ((int) n < 0)
			   { n = EXSIZE_T_MAX; break; }
  }
  return (n);
}

//------------------------------------------------
//	⥫ ᪮ 㭪樨,
//	뢠  ⮬᪮ 㢥祭
//	ࠧ ᨢ  NULL, ᫨ 맮
//	᪮ 㭪樨  ॡ.

void	(* VDECL _exalloc_auto_handler)(void);

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	室   ࠭ ᨢ
//	 ⮬ 砥, ᫨  ।ᬮ७
//	⮬᪮ 㢥祭 ࠧ ᨢ.
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.

void	(* VDECL _exindex_range_handler)(void) = abort;

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	饭  ᪮ NULL-㪠⥫.
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.

void	(* VDECL _exnull_pointer_handler)(void) = abort;

//------------------------------------------------
//	誠 ᪮ ᨢ,
//	ਬ  ᢠ
//	᪨ 㪠⥫ 祭 NULL.

__exblock VDECL	__EXNULL;

#ifdef __cplusplus
}
#endif
