/*      exarray.h

	᪨ ᨢ  ⮬᪮ ஢મ .
        http://www.imach.uran.ru/exarray

	(C) ..஢,   PAH, 1998 - 2000
	All Rights Reserved.
*/
#ifndef _EXARRAY_H
#define _EXARRAY_H

#ifndef __cplusplus
#error	Must use C++ for the template exarray.
#endif

#include <stddef.h>
#include <limits.h>

//	 ।祭  ࣠樨
//	ᨢ  ஫ ᮢ 
//	⮬᪨ 㢥祭 ࠧ஢.
//
//	᪨ ᨢ  ᢮⢮
//	⮬᪮ 㢥祭 ࠧ 
//	室   ࠭ ᨢ.
//
//	᪨ 㪠⥫ ।祭 
//	樨 ⮢ ᪮ ᨢ
//	 ⮬᪨ 㢥祭 ࠧ.
//
//	࠭祭 㪠⥫ ।祭 
//	樨   ᪨ ᨢ
//	 䨪樥 ࠧ஢  ஫ ᮢ.
//	࠭祭 㪠⥫  ਬ
//	 ࣠樨 ஫ ᮢ 
//	⠯ ⫠ ணࠬ.
//
//	:
//	exarray<⨯> ;	᪨ ᨢ.
//	expoint<⨯> ;	᪨ 㪠⥫,
//	exptr<⨯>   ;	࠭祭 㪠⥫.
//
//	   樨 몠 ,
//	 ᨢ  㪠⥫ﬨ,  ᪫祭
//	७  䠩 exarray.hlp.

template <class T> class exarray;
template <class T> class expoint;
template <class T> class exptr;

//================================================
//	।⠢ ᪣ ᨢ.
//================================================

//	᪨ ᨢ  뢭
//	 , c   ⪮:
//	1)  ᨢ.   
//	   ஢ 㫥  ⪠
//	   , ᫥ 祣 뢠 .
//	    ⠬ ᪠ 饭 
//	   ⥭  .
//      2) 㫥 ⮪,  
//         ࠧ饭 ᪮쪨 ⮢
//	    ⨯ (. ).
//	   ᫨ 㫥 ⮪ ᮤন
//	   ⨬ 祭  ⨯,
//	        饭 
//	   ᨢ  ஫ .
//	3) १ࢨ஢ , ࠧ
//	   ன । ⮬᪨.
//
//	稥 㫥 ⪠ ⢥
//	 饭  ᪮ ᨢ
//	 ஫ , .. 
//	ᤥ ।᪠㥬묨 ᫥⢨
//	࠭ 訡 - 饭 
//	, ࠢ  ⮢.
//
//	 楫   "⮩"
//	᪨ ᨢ, .. ᨢ 
//	⮢,  ࠧ 㫥
//	⮪   㣨 "묨"
//	ᨢ ⮣  ⨯.
//
//	 EXARRAY_EXTRA_ITEMS(T) 
//	쭮 ᫮ ⮢ 
//	⨯ T  㫥 ⪥ .
//	  ਭ 祭  0
//	 . ⭮ 祭 - 1.

#ifndef	EXARRAY_EXTRA_ITEMS
#define	EXARRAY_EXTRA_ITEMS(T)	(1)
#endif

//================================================
//	ࠬ 樨.
//================================================

//	  ࠢ ࠭樥.
//	᫨ ࠭ ᮮ⢥ ⠭
//	C++ ISO/IEC 14882,   ⢮
//	 ,  ᫥  ,
//	  ᮧ ஡  ࠭樨.
//
//	ALLOW_EXARRAY_ADDSUB	 - ࠧ蠥 樨
//		+  -  ᪨ ᨢ 
//		楫᫥ ᬥ饭,  १
//		祣 ந ᪨ 㪠⥫.
//		( +  -  । ⮫쪮
//		 蠡 㪠⥫).
//
//	ALLOW_EXARRAY_SELECTION	 - ࠧ蠥
//		ॣ㧪  ->.
//
//	ALLOW_EXARRAY_ITERATORS	 - । ᢮⢠
//		 ⮤  ਬ 蠡
//		 ⢥ ஢  ⥩஢
//		⥪ STL,  ⠪ ࠧ蠥
//		ॣ㧪  ->.
//
//	ALLOW_EXARRAY_STRING	 - ࠧ蠥
//		ॣ㧪 㭪権  string.h  
//		ᮢ exarray<char>  expoint<char>.
//		᫨    ।, 
//		᪨ ᨢ  㪠⥫
//		 । ⮫쪮  ⢥
//		ࠬ஢ const char *.
//
//	ALLOW_EXARRAY_EXCEPTIONS - ࠧ蠥 
//		ᯮ짮 । ࠡ⪨
//		᪫祭 (ॡ, ᫨ 
//		 ᪫祭  c
//		⮢ ᪮ ᨢ).
//
//	ALLOW_EXARRAY_CHARTYPE   - ⠭
//		⮬᪨, ᫨ ⨯ char
//		⫨祭  signed/unsigned char.
//
//	ALLOW_EXARRAY_SHEDULING  - ⨬
//		  ஢ Pentium.
//		⠭ ⮬᪨ 
//		ᨬ  ⨯ ࠭.
//
//	NCHECKPTR		 - ⪫砥
//		⫠  蠡.
//		⠭ ⮬᪨,
//		᫨ ।  NDEBUG.

//	#define ALLOW_EXARRAY_ADDSUB
//	#define	ALLOW_EXARRAY_SELECTION
//	#define	ALLOW_EXARRAY_ITERATORS
//	#define ALLOW_EXARRAY_STRING
//	#define ALLOW_EXARRAY_EXCEPTIONS
//	#define ALLOW_EXARRAY_CHARTYPE
//	#define ALLOW_EXARRAY_SHEDULING
//	#define NCHECKPTR

#ifdef	NDEBUG
#define NCHECKPTR
#endif

//------------------------------------------------
//	ᯮ ⨯ ࠭.

//	Borland C++
#ifdef	__TURBOC__
#if     __TURBOC__ <= 0x410
#undef	ALLOW_EXARRAY_EXCEPTIONS
#endif
#if     __TURBOC__ >= 0x460
#define	ALLOW_EXARRAY_CHARTYPE
#endif
#endif

//	Visual C++
#ifdef  _MSC_VER
#define	ALLOW_EXARRAY_CHARTYPE
#define	ALLOW_EXARRAY_SHEDULING
#endif

//	C++ ISO/IEC 14882
#if	__cplusplus > 199711L
#define	ALLOW_EXARRAY_CHARTYPE
#endif

//------------------------------------------------
//	⥫ 砥 䠩.

#ifdef	ALLOW_EXARRAY_ITERATORS

#include <iterator>
#define	ALLOW_EXARRAY_SELECTION

#else //ALLOW_EXARRAY_ITERATORS

#ifdef	ALLOW_EXARRAY_SELECTION
#ifdef  _MSC_VER
#include <xstddef>
#endif//_MSC_VER
#endif//ALLOW_EXARRAY_SELECTION

#endif//ALLOW_EXARRAY_ITERATORS

//------------------------------------------------
//	  樨 ᮣ襭  
//	 譨 ꥪ⠬  㭪ﬨ.
//	VDECL	- ꥪ
//	STDECL	- 㭪

#ifdef	__STDC__
#define STDECL
#else
#define	STDECL	__cdecl
#endif
#define	VDECL

//------------------------------------------------
//	譨 뫪 ,  "C", ⮡
//	஢ ८ࠧ .
//	  ७ ꥪ 㫨
//	 ࠧ묨 ﬨ ஢.

#ifdef __cplusplus
extern "C" {
#endif

//================================================
//	  । ᪮ .
//================================================
//	   த㡫஢
//	 㣨 砥 䠩,

#ifndef	_EXALLOC_MAIN
#define	_EXALLOC_MAIN

//------------------------------------------------
//	ࠬ । ᪮ ,
//	EXSIZE_T_MAX        - ᨬ쭮 祭,
//		뤠  ⢥ १
//		楫᫥ ᫥  ஫
//		९ ࠧ來 ⪨.
//	EXCALCBLOCKSIZE_SYS - ࠧ ⥬
//		  , 騩
//		 ਬ塞  (᫨
//		ࠧ ⥭,   㪠
//		 業,    16).
//	EXCALCBLOCKSIZE_MOD - 砫 ࠧ
//		   ⮬ ⥬
//		    
//		㭪樨 excalcblocksize, 
//		64**n +/- 16 .
//	EXCALCBLOCKSIZE1..5 -  砫 ࠧ
//		    ⥬
//		૮, ⠭  
//		㭪樨 excalcblocksize  ᪮쪮
//		᫥ ࠧ஢, 뤠
//		⮩  㭪樥.
//	EXCALCBLOCKSIZE_MAX - ᨬ ࠧ
//		    ⥬
//		,  ᪠
//		㭪ﬨ । 
//		(樮 ⥬  
//		 뢠 ⥫ 
//		࠭祭).

#define EXSIZE_T_MAX	    ((sizeof(size_t)==2)? UINT_MAX: INT_MAX)
#define EXCALCBLOCKSIZE_SYS (sizeof(size_t) * 2)
#define EXCALCBLOCKSIZE_MOD (sizeof(size_t) * 32 - 16)
#define EXCALCBLOCKSIZE_1   (EXCALCBLOCKSIZE_MOD * 1 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_2   (EXCALCBLOCKSIZE_MOD * 2 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_3   (EXCALCBLOCKSIZE_MOD * 3 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_4   (EXCALCBLOCKSIZE_MOD * 6 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_5   (EXCALCBLOCKSIZE_MOD * 9 - EXCALCBLOCKSIZE_SYS)
#define EXCALCBLOCKSIZE_MAX (EXSIZE_T_MAX - EXCALCBLOCKSIZE_SYS * 2)

//------------------------------------------------
//	᫥ ᫥  ஫
//	९ ࠧ來 ⪨.
//	  exmuladd (s,n,k) = s * n + k.
//	  exmul    (s,n)   = s * n.
//	  exadd    (n,k)   = n + k.
//	 樨 ⨬쭮  ᫥
//	⠢ ⠭   s  k.
//	 ९ 뤠 EXSIZE_T_MAX.

#ifdef	__cplusplus

inline	size_t	exmuladd (size_t s, size_t n, size_t k)
{
  return ((n <= (EXSIZE_T_MAX - k) / s)? (n * s + k): EXSIZE_T_MAX);
}

inline	size_t	exmul (size_t s, size_t n)
{
  return ((s == 1)? n: (n <= EXSIZE_T_MAX / s)? n * s: EXSIZE_T_MAX);
}

inline	size_t	exadd (size_t n, size_t k)
{
  return (exmuladd (1, n, k));
}

#else //__cplusplus

size_t	    STDECL exmuladd	(size_t s, size_t n, size_t k);	// s*n+k
size_t	    STDECL exmul	(size_t s, size_t n);		// s*n
size_t	    STDECL exadd	(size_t n, size_t k);		// n+k
#define	exmul(s,n)		exmuladd((s),(n),0)
#define exadd(n,k)		exmuladd(1,(n),(k))

#endif//__cplusplus

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	訡 । .
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.
//	᫨ 㪠⥫ ࠢ NULL,  ࠡ⪠
//	믮 㭪樥, ⠭
//	 set_new_handler  new.h, ᫨ 
//	 ⠪ ,  뢠 abort().

extern	void (* VDECL _exalloc_fail_handler)(void);

//------------------------------------------------
//	㭪 excalcblocksize 뢠
//	⨬ ࠧ    ,
//	     ॡ㥬. 
//	᫨ 襭 ࠧ ᫨誮 ,
//	 뤠 EXSIZE_T_MAX.

size_t	STDECL	excalcblocksize (size_t blocksize);

//------------------------------------------------
//	 exalloc  㭪 exmalloc
//	뤥  ,  ﬨ.
//
//	 exrealloc  㭪 exmrealloc
//	뤥, 㤫, 㪮稢 
//	᢮  ,  ⠪
//	  ⮪.
//
//	     .
//	 ९ ࠧ來 ⪨ 
//	 墠⪥  뢠 㭪,
//	᢮ _exalloc_fail_handler.
//	᫨ _exalloc_fail_handler == NULL,
//	 뢠 㭪, ⠭
//	 set_new_handler  new.h, ᫨ 
//	 ⠪ ,  뢠 abort().
//
//	㭪 exfree ᢮  .

#define exalloc(T,blocksize) ((T*) exmalloc (exmul (sizeof(T),(blocksize))))

#define exrealloc(T,p,blocksize,memset_start,memset_stop) (	\
		exmrealloc ((void**)&(p),			\
			exmul (sizeof(T), (blocksize)),		\
			sizeof(T) * (size_t)(memset_start),	\
			sizeof(T) * (size_t)(memset_stop)))

void*	STDECL	exmalloc   (size_t blocksize);
void	STDECL	exmrealloc (void** p, size_t blocksize,
			    size_t memset_start,
			    size_t memset_stop);
void	STDECL	exfree     (void* p);

//------------------------------------------------
//	⥫ ᪮ 㭪樨,
//	뢠  ⮬᪮ 㢥祭
//	ࠧ ᨢ  NULL, ᫨ 맮
//	᪮ 㭪樨  ॡ.
//	 ਬ  ஢
//	⮬᪮ 㢥祭 ࠧ.
//	ࢮ砫쭮 祭 - NULL.

extern	void (* VDECL _exalloc_auto_handler)(void);

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	室   ࠭ ᨢ
//	 ⮬ 砥, ᫨  ।ᬮ७
//	⮬᪮ 㢥祭 ࠧ ᨢ.
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.

extern	void (* VDECL _exindex_range_handler)(void);

//------------------------------------------------
//	⥫ 㭪樨, 뢠 
//	饭  NULL-㪠⥫.
//	㭪  㤨 ᪫祭
//	 ४ 믮 ணࠬ.

extern	void (* VDECL _exnull_pointer_handler)(void);

#endif//_EXALLOC_MAIN

//================================================
//	ᯮ⥫ .
//================================================

//------------------------------------------------
//	, 筠 ᪮
//	ᨢ   ⮢.

struct	__exblock { void* e; size_t len; };

//------------------------------------------------
//	誠 ᪮ ᨢ,
//	ਬ  ᢠ
//	᪨ 㪠⥫ 祭 NULL.

extern	VDECL __exblock	__EXNULL;

#ifdef __cplusplus
}
#endif

//================================================
//	ᯮ⥫ 蠡  맮
//	஢  ஢ 
//	। .
//================================================

template <class T> class __EXRELOC
{
  T value;
  __EXRELOC		   (const __EXRELOC<T>&);
  __EXRELOC<T>& operator = (const __EXRELOC<T>&);
public:
  __EXRELOC		   () {};
  void* operator new	(size_t, void* p)
				 { return p;	}
#ifdef	_MSC_VER
#if	_MSC_VER >= 1200
  void  operator delete (void*, void*)	{ ; }	// VC 6.0
#endif
#endif
  void  operator delete (void*)		{ ; }
};

//================================================
//	 ᨢ  ६묨 ࠧࠬ.
//================================================

//	 뢠 ᨢ  ६묨
//	ࠧࠬ  ਬ  ஦
//	ந ᮢ.
//	 ।⢥ ᮧ
//	ꥪ⮢ exblock  ।ᬮ७.

template <class T> class exblock
{
protected:
  T*		e;	//  ᨢ.
  size_t	len;	// ᫮ ⮢.

//	᪨ ᨢ ࠧ஬  
//	sizeof(T) * EXARRAY_EXTRA_ITEMS(T).

  static T* stub ();

//	। . ।
//	ࠧ    ᫮ ⮢.

  void 	  realloc  (size_t blocksize, size_t n);

//	뢠 ࠡ ணࠬ  ⪥
//	饭   i >= len.

  T*	  range	(size_t i)	const;

//	।    
//	 ᮬ i >= len. 뤠 e.

  T*	  grow	(size_t i)	const;

//	   饭, ..
//	 ।⢥ ᮧ
//	ꥪ⮢ exblock  ।ᬮ७.
//	  ந  ᫥
//	 e = stub()  len = 0, ᫥ 祣,
//	 室, 맢 室騩
//	⮤ । ,  
//	᫥ 맢 ⮤ clear().

  exblock ()		{ /* e = stub(); len = 0; */	}
  ~exblock()		{ /* clear(); */		}

private:

//	 ஢ ᢠ ᨢ
//	  ।  㭪樨  祭
//	 ਢ 
//	஢   ᢠ.
//	।   .
//	ᨢ exblock  ।  㭪樨
//	 뫪,  १ ᪨
//	 ࠭祭 㪠⥫.

  exblock		 (const exblock<T>&);
  exblock<T>& operator = (const exblock<T>&);

public:

//	 쭮 ࠧ  
//	 ॡ㥬  ⮢  ᨢ.
//	 ९ 뤠 EXSIZE_T_MAX.

  size_t min_blocksize (size_t n) const
  {
    return (exmuladd (
	sizeof(T), n,
	sizeof(T) * EXARRAY_EXTRA_ITEMS(T)));
  }

//	 ᨬ쭮  ᫠
//	⮢  ᨢ  ࠧ 
//	,  襬 min_blocksize (0).

  size_t max_size (size_t blocksize) const
  {
    return (blocksize /
	    sizeof(T) - EXARRAY_EXTRA_ITEMS(T));
  }

//	STL-⮤ ࠢ ࠧ஬:
//	  size     () ᫮ ⮢.
//	  capcity () ᫮ ⮢,   । .
//	  max_size () ᨬ쭮  ᫮ ⮢.
//	  empty    () । size() == 0.
//	  resize  (n) ⠭ ᫠ ⮢.

  size_t  size     ()	const	{ return len;				}
  size_t  capacity ()	const;
  size_t  max_size ()	const	{ return max_size (EXCALCBLOCKSIZE_MAX);}
  int	  empty    ()	const	{ return (size() == 0);			}
  void	  resize   (size_t n);

//	⨬஢ ⮤ ࠢ ࠧ஬:
//	  chsize  (i) ।   ⮢ 0..i
//	  expand  (i) ।   ⮢ 0..i ᫨ i >= len.
//	⮤ chsize  expand  ਬ  ᪨
//	 窨 ७ ந⥫쭮 ⪠ ணࠬ.
//	 ⮤ 㢥稢 ᫮ ⮢, ᫨  
//	襭. ⮤ chsize 㬥蠥 ᫮ ⮢,
//	᫨    襭. ⮣ ᫮
//	⮢ । ꥬ । 
//	    襭.
                         
  void 	  _chsize  (size_t i);		// ⨬஢ chsize.
  void 	  _chsize  (size_t i, const T **p);
  void 	  chsize   (size_t i)
		{ int m = i/2; if ((int)len - m <= m) _chsize (i);	}
  void 	  chsize   (size_t i, const T **p)                               
		{ int m = i/2; if ((int)len - m <= m) _chsize (i,p);	}
  void 	  expand   (size_t i)		  const
		{ if (len <= i)  ((exblock<T>*)this)->_chsize (i);	}
  void 	  expand   (size_t i, const T **p) const
		{ if (len <= i)  ((exblock<T>*)this)->_chsize (i,p);	}

//	⫠ ⮤ ࠢ ࠧ஬:
//	  checkchsize (i) ।   ⮢ 0..i
//	  checkexpand (i) ।   ⮢ 0..i
//			  ᫨ i >= len.
//	  checksize   (i) ஢ઠ i < len.
//
//	 稨  NCHECKPTR ⮤ checkchsize (i) 
//	checkexpand (i) , ᮮ⢥⢥, ⮤
//	chsize (i)  expand (i),  checksize (i)   祣.
//
//	 ⢨  NCHECKPTR ⫠ ⮤
//	⠭ ᫮ ⮢, ࠢ i + 1.
//	᫨  饭  ⮤ checksize (i)  ᫮
//	⮢  ⥪饣,  뢠 㭪,
//	᢮ 㪠⥫ _exindex_range_handler.

#ifdef	NCHECKPTR
  void	  checkchsize (size_t i) { chsize (i);		}
  void	  checkexpand (size_t i) { expand (i);		}
  void	  checksize   (size_t i) { (void) (i);		}
#else
  void	  checkchsize (size_t i) { resize (i + 1);	}
  void	  checkexpand (size_t i) { resize (i + 1);	}
  void	  checksize   (size_t i) { if (len <= i) range (i); resize (i + 1); }
#endif

//	  ᨢ  ஢ન :
//	  item   (i)	.
//        base   ()	⥫ o ᨢ.
//	뫪    㪠⥫ ⢨⥫
//	  ,  ࠧ ᨢ  .

      T&  item	 (int i)		{ return e[i];		}
const T&  item	 (int i)	const	{ return e[i];		}
      T*  base	 ()			{ return (e);		}
const T*  base	 ()		const	{ return (e);		}

//	  ᨢ  ஢મ :
//	  at    (i)   .
//	 室   ࠭ ᨢ
//	뢠 abort()   㭪,
//	᢮ _exindex_range_handler.

#ifdef	ALLOW_EXARRAY_SHEDULING

      T&  at	(int i)
	{ register T* p = e; if (len <= (size_t)i) p = range(i); return p[i]; }
const T&  at	(int i)		const
  { const register T* p = e; if (len <= (size_t)i) p = range(i); return p[i]; }

#else //ALLOW_EXARRAY_SHEDULING

      T&  at     (int i)
		{ if (len <= (size_t)i) range (i); return e[i];	} 
const T&  at     (int i)	const
		{ if (len <= (size_t)i) range (i); return e[i];	} 

#endif//ALLOW_EXARRAY_SHEDULING

//	  ᨢ  ஢મ 
//	 ⮬᪨ 㢥祭 ࠧ.
//	  access (i)	.
//	 室   ࠭ ᨢ
//	ࠧ ᨢ ⮬᪨ 㢥稢.
//	 㢥祭 ࠧ ஢ 㫥
//	, ᫥ 祣    ⮢
//	믮   㬮砭.
//
//	᫨ 㢥祭 ࠧ  -
//	९ ࠧ來 ⪨  墠⪨
//	,  믮 ࠡ⪠ 訡
//	 뢠 ଠ쭮 室 믮
//	ணࠬ (. ᠭ exmrealloc).
//      :
//	  ⥫  ,
//	   讥 ⥫쭮 ᫮, 
//	     ⨯ T, ஬ char,
//	  ਢ  ࠡ⪥ 訡.
//
//	 ᯥ譮 ।  뤠
//	뫪   ᨢ  祭 
//	ᢠ 祭. 뫪 ⢨⥫쭠
//	  ,  ࠧ ᨢ  .

#ifdef	ALLOW_EXARRAY_SHEDULING

      T&  access (int i)
	{ register T* p = e; if (len <= (size_t)i) p = grow (i); return p[i]; }
const T&  access (int i)	const
  { const register T* p = e; if (len <= (size_t)i) p = grow (i); return p[i]; }

#else //ALLOW_EXARRAY_SHEDULING

      T&  access (int i)
		{ if (len <= (size_t)i) grow (i); return e[i];	}
const T&  access (int i)	const
		{ if (len <= (size_t)i) grow (i); return e[i];	}

#endif//ALLOW_EXARRAY_SHEDULING

#ifdef	ALLOW_EXARRAY_ITERATORS

//	।  ⥪ STL.
//	᪨ ᨢ  㯠 
//	⥩  ࠭祭 ஬ ⮤.

typedef	      T	 	value_type;	//  .
typedef	   size_t   	size_type;	// size()
typedef	ptrdiff_t	difference_type;// operator -
#ifdef	NCHECKPTR
typedef	      T*  	iterator;	// begin(), end()
typedef	const T*  	const_iterator;	// begin(), end()
#else
typedef	      exptr<T>  iterator;	// begin(), end()
typedef	const exptr<T>	const_iterator;	// begin(), end()
#endif
typedef	      T*	pointer;	// operator ->
typedef	const T*	const_pointer;	// operator ->
typedef       T&	reference;   	// operators *, []
typedef const T&	const_reference;// operators *, []

//	  ⥪ STL.
//        begin	()    뢠   .
//        end	()    뢠  , ᫥騩
//		       ᫥.
//	᫨ ⮢ ,  begin() == end().
//	   *end() .
//	 ஫  㯠 ࠭祭
//	㪠⥫, ᯥ稢騩 ஫
//	ᮢ,  ᫨ । 
//	NCHECKPTR -   㪠⥫.
//	 ⢨⥫   ,
//	 ࠧ ᨢ  .

#ifdef	NCHECKPTR

iterator        begin ()	{ return base();		}
const_iterator  begin ()  const	{ return base();		}

iterator        end   ()	{ return base()+size();		}
const_iterator  end   ()  const	{ return base()+size();		}

#else

iterator	begin ()	{ return exptr<T>(e,len);	}
const_iterator  begin ()  const	{ return exptr<T>(e,len);	}

iterator	end   ()	{ return exptr<T>(e,len,len);	}
const_iterator  end   ()  const	{ return exptr<T>(e,len,len);	}

#endif

#endif//ALLOW_EXARRAY_ITERATORS

//	STL-樨  ᨢ:
//	  clear      ()	⪠ ᪮ ᨢ.
//	  swap      (m)	⠭ ᪨ ᨢ
//			 ஢ ⮢.

  void    clear     ()		{ realloc (0, 0);	}
  void    swap      (exblock<T>&);

//	㦥 ⮤:
//	  _setbase (p) ᢠ  ᨢ.
//	  _setsize (n) ᢠ ᫠ ⮢.
//	᪠:
//	1) ᢠ 㫥 㪠⥫ 
//	   ᫮ ⠭ ᫠ ⮢  0.
//	2) ᢠ  ᨢ, 
//	     뤥﫠 㭪ﬨ
//	   exmalloc  exrealloc,  ⮬
//	   ࠧ     blocksize
//	    ᫮ ⮢ n  ⢥
//	   ᫮ blocksize >= min_blocksize (n).
//	ᢠ ᨢ, 祭 ஬
//	new  ᫥, ..   ࠧ襭
//	⠭⮬ ++ ( ⨯  ਢ묨
//	ࠬ new ᯮ ᮢ⨬
//	ଠ  ).

  void	  _setbase  (T* p)	{ e   = p;		}
  void    _setsize  (size_t n)	{ len = n;		}
};

//	饭 ⮤ stub() 뤠 㪠⥫ 
//	᪨ ᨢ ࠧ஬  
//	sizeof(T) * EXARRAY_EXTRA_ITEMS(T).

template <class T> T* exblock<T>::stub()
{
  static char _stub
	[sizeof(T) * (EXARRAY_EXTRA_ITEMS(T)? EXARRAY_EXTRA_ITEMS(T): 1)];
  return (T*)(_stub);
};

//	饭 ⮤ realloc (blocksize, n)
//	⠭ ࠧ    
//	blocksize  ᫮ ⮢ n. 
//	  ᫮ ⮢  ⢥
//	᫮ blocksize >= min_blocksize (n),
//	 ᪫祭  㤠 ᨢ,
//	 ॡ blocksize == n == 0.
//
//	 㢥祭 ᫠ ⮢ 믮
//	㫥 뤥   뢠
//	 ⮢.  㬥襭
//	᫠ ⮢ 뢠 .
//	맮 ஢ ॠ   ਠ:
//	 ।  ᪠
//	᪫祭  , ன - .

template <class T> void  exblock<T>::realloc (size_t blocksize, size_t n)
{
  T* p = e;		//   e.

  if (p == 0)		// ⨪ 饭 
  {			// ᪮ 0-㪠⥫.
    if (this == (exblock<T>*)&__EXNULL)
      (*_exnull_pointer_handler)();
  }
  else if (p == stub())	// ᫨ p 祭  stub(),
  {			//   ᫥ 㫨.
    p = 0;
  }
  else
  {
#ifdef ALLOW_EXARRAY_EXCEPTIONS
    for (;;)
    {
    try
    {
#endif
   			// 맮 ஢ 
    while (len > n)	// 㤠  㪮祭.
	{ --len; delete (__EXRELOC<T> *) (p + len); }
#ifdef ALLOW_EXARRAY_EXCEPTIONS
    break;
    }
    catch (...) { };
    }
#endif
  }
  ::exmrealloc (	// । .
	(void **)&p,	// ⥫  .
	blocksize,	//  ࠧ.
	sizeof(T) * len,// ࠭ 㫥.
	sizeof(T) * (n + EXARRAY_EXTRA_ITEMS(T))
  );
  if ((e = p) == 0)	//   e.
  {                	//  ⮣ ᨢ e
    e = stub();      	//  ⮤ stub().
  }
  else
  {			// 맮 ஢ 
    while (len < n)	// ᮧ  㤫.
	{ new (p + len)__EXRELOC<T>; ++len; }
  }
}

//	饭 ⮤ range (i) 뢠
//	 饭    i >= len
//	 뢠 ࠡ ணࠬ.

template <class T> T* exblock<T>::range (size_t /*i*/) const
{
  if (this == (exblock<T>*)&__EXNULL)
	(*_exnull_pointer_handler)();
  else	(*_exindex_range_handler)();
  return (e);
};

//	饭 ⮤ grow (i) 뢠
//	 饭    i >= len
//	 ⮬᪮ 㢫祭 ࠧ
//	। ।  뢠
//	㭪, ᢮ _exalloc_auto_handler.

template <class T> T* exblock<T>::grow (size_t i) const
{
  if (_exalloc_auto_handler) (*_exalloc_auto_handler)();
  size_t blocksize = ::excalcblocksize (
    exmuladd (sizeof(T), i,
	      sizeof(T) * (1 + EXARRAY_EXTRA_ITEMS(T))));
  ((exblock<T>*)this)->realloc (blocksize, max_size (blocksize));
  return (e);
};

//	⮤ capacity() 뤠 ᫮ ⮢,
//	  । .
//	 ᫮ ᥣ   size().

template <class T> size_t exblock<T>::capacity () const
{
  return (max_size (::excalcblocksize (min_blocksize (len))));
};

//	⮤ resize (n) c⠭  ᫮
//	⮢  ।   ᫠
//	⮢,  襣 .

template <class T> void exblock<T>::resize  (size_t n)
{
  realloc (::excalcblocksize (min_blocksize (n)), n);
};

//	⮤ _chsize (i) ⠭ ᫮ ⮢,
//	 襥 .

template <class T> void exblock<T>::_chsize (size_t i)
{
  size_t blocksize = ::excalcblocksize (
    exmuladd (sizeof(T), i,
	      sizeof(T) * (1 + EXARRAY_EXTRA_ITEMS(T))));
  realloc (blocksize, max_size (blocksize));
};

//	䨪 ⮤ _chsize (i), 
//	᪮४஢ 㪠⥫   ᨢ
//	 ६饭 ᨢ.
//	⥫ ४ ⮫쪮  ⮬ 砥,
//	᫨  ⭮c   ᨢ.

template <class T> void exblock<T>::_chsize (size_t i, const T **p)
{
  if (e <= *p && *p < e + size())
  {
    size_t k = (size_t) ((*p) - e); _chsize (i); *p = e + k;
  }
  else _chsize (i);
};

//	⠭ ᪨ ᨢ
//	 ஢ ⮢.

template <class T> void  exblock<T>::swap (exblock<T>& m)
{
  T*     temp_base = base();
  size_t temp_size = size();
  _setbase   (m.base());
  _setsize   (m.size());
  m._setbase (temp_base);
  m._setsize (temp_size);
};

//================================================
//	 ᪮ ᨢ.
//================================================

template <class T> class exarray: public exblock<T>
{

//	 ஢ ᢠ ᪨
//	ᨢ   ।  㭪樨 
//	祭  ਢ 
//	஢   ᢠ.
//	।   .
//	᪨ ᨢ  । 
//	㭪樨  뫪, १ ᪨
//	 ࠭祭 㪠⥫,  ⠪ १
//	㪠⥫ const T*.

  exarray		 (const exarray<T>&);
  exarray<T>& operator = (const exarray<T>&);

public:

//	 ᪮ ᨢ.
//	᪮ e   ⫨筮  0,
//	 e ᢠ 㪠⥫
//	 ᪨ ᨢ ⨯ T.

  exarray ()			{ e = stub(); len = 0;	}

//	 ᪮ ᨢ
//	  砫 ᫮ ⮢.

/*explicit*/ exarray (size_t n);

//	 믮 ᢮ .

  ~exarray()			{ clear();		}

//	⮬᪮ ८ࠧ  const T*
//	ਬ  ।  ᨢ
//	 㭪 १ ࠬ const T*  
//	᪨ . ᪮ 祭
//	᪮ ᨢ - ⨭.

  operator const T*()	  const	{ return base();	}

//	  ᨢ  ஢મ 
//	 ⮬᪨ 㢥祭 ࠧ.

      T& operator [] (unsigned int i)		{ return (access (i));	}
const T& operator [] (unsigned int i)	const	{ return (access (i));	}
      T& operator [] (int i)			{ return (access (i));	}
const T& operator [] (int i)	  	const	{ return (access (i));	}
      T& operator [] (unsigned short i)		{ return (access (i));	}
const T& operator [] (unsigned short i) const 	{ return (access (i));	}
      T& operator [] (short i)			{ return (access (i));	}
const T& operator [] (short i)		const	{ return (access (i));	}
      T& operator *  ()		      		{ return (access (0));	}
const T& operator *  ()			const	{ return (access (0));	}
#ifdef	ALLOW_EXARRAY_SELECTION
      T* operator -> ()		      		{ return (T*)(&access (0)); }
const T* operator -> ()			const	{ return (T*)(&access (0)); }
#endif

//	䬥᪨ 樨.

#ifdef	ALLOW_EXARRAY_ADDSUB

private:
expoint<T> _add (int i)	const	{ return (expoint<T>(*(exblock<T>*)this, i));}
expoint<T> _sub (int i)	const	{ return (expoint<T>(*(exblock<T>*)this,-i));}
public:

      expoint<T>  operator +  (unsigned int i)		{ return (_add (i)); }
const expoint<T>  operator +  (unsigned int i)	 const	{ return (_add (i)); }
      expoint<T>  operator +  (int i)			{ return (_add (i)); }
const expoint<T>  operator +  (int i)		 const	{ return (_add (i)); }
      expoint<T>  operator +  (unsigned short i)	{ return (_add (i)); }
const expoint<T>  operator +  (unsigned short i) const	{ return (_add (i)); }
      expoint<T>  operator +  (short i)			{ return (_add (i)); }
const expoint<T>  operator +  (short i)		 const	{ return (_add (i)); }

      expoint<T>  operator -  (unsigned int i)		{ return (_sub (i)); }
const expoint<T>  operator -  (unsigned int i)	 const	{ return (_sub (i)); }
      expoint<T>  operator -  (int i)			{ return (_sub (i)); }
const expoint<T>  operator -  (int i)		 const	{ return (_sub (i)); }
      expoint<T>  operator -  (unsigned short i)	{ return (_sub (i)); }
const expoint<T>  operator -  (unsigned short i) const 	{ return (_sub (i)); }
      expoint<T>  operator -  (short i)			{ return (_sub (i)); }
const expoint<T>  operator -  (short i)		 const	{ return (_sub (i)); }

#else //ALLOW_EXARRAY_ADDSUB

//	஢ 䬥᪨ 権.
//	᫨   ᤥ,  㤥 ஢
//	८ࠧ  const T*  樨 
//	㪠⥫ﬨ.

private:

void	operator +  (unsigned int i)		;
void	operator +  (unsigned int i)	const	;
void	operator +  (int i)			;
void	operator +  (int i)		const	;
void	operator +  (unsigned short i)		;
void	operator +  (unsigned short i)	const	;
void	operator +  (short i)			;
void	operator +  (short i)		const	;

void	operator -  (unsigned int i)		;
void	operator -  (unsigned int i)	const	;
void	operator -  (int i)			;
void	operator -  (int i)		const	;
void	operator -  (unsigned short i)		;
void	operator -  (unsigned short i)	const	;
void	operator -  (short i)			;
void	operator -  (short i)		const	;

#endif//ALLOW_EXARRAY_ADDSUB

private:

//	஢ 権  ᠬ long  char
//	 뤠  ⭮ ⨪.

void	operator [] (unsigned long i)		;
void	operator [] (unsigned long i)	const	;
void	operator [] (long i)			;
void	operator [] (long i)		const	;
void	operator [] (unsigned char i)		;
void	operator [] (unsigned char i)	const	;
void	operator [] (signed char i)		;
void	operator [] (signed char i)	const	;

void	operator +  (unsigned long i)		;
void	operator +  (unsigned long i)	const	;
void	operator +  (long i)			;
void	operator +  (long i)		const	;
void	operator +  (unsigned char i)		;
void	operator +  (unsigned char i)	const	;
void	operator +  (signed char i)		;
void	operator +  (signed char i)	const	;

void	operator -  (unsigned long i)		;
void	operator -  (unsigned long i)	const	;
void	operator -  (long i)			;
void	operator -  (long i)		const	;
void	operator -  (unsigned char i)		;
void	operator -  (unsigned char i)	const	;
void	operator -  (signed char i)		;
void	operator -  (signed char i)	const	;

#ifdef	ALLOW_EXARRAY_CHARTYPE
void	operator [] (char i)			;
void	operator [] (char i)		const	;
void	operator +  (char i)			;
void	operator +  (char i)		const	;
void	operator -  (char i)			;
void	operator -  (char i)		const	;
#endif
};

//	 ᪮ ᨢ
//	  砫 ᫮ ⮢.
//	 뢠  ᪠
//	᪫祭  뤥  
//	஢  ᨢ -  ⮬
//	砥 ந ⮩ ᪨ ᨢ,
//	 ண  ॡ .

template <class T> exarray<T>::exarray (size_t n)
{
//	 ⮣ ᨢ  ࠡ祬 ꥪ.

  exarray<T> tmp;
  e = tmp.e; len = tmp.len;

//	뤥   ஢ 
//	ᨢ  ࠡ祬 ꥪ. ᫨ 
//	᪫祭,  ⪨  ᨢ 
//	㤥 㤠 c஬ ࠡ祣 ꥪ.

  tmp.resize (n);

//	塞 ⠬ ᨢ  ࠡ祬 
//	㥬 ꥪ.

  swap (tmp);
};


//================================================
//	 ᪨ 㪠⥫.
//================================================

//	᪨ 㪠⥫ ᮤন ᬥ饭
//	⭮⥫쭮 砫 ᪮ ᨢ,
//	஥  室  ࠭ ᨢ,
//	 ⠪   ⥫.
//	⥫쭮 ᬥ饭 ⭮
//	讬 ⥫쭮 ᬥ饭 
//	⥬   .

template <class T> class expoint
{
protected:
  exblock<T>*	a;	// ᪨ ᨢ.
  int	    	k;	// 饭  ᨢ.
			// ⠭ ᬥ饭.
  size_t  lf   (size_t n)	const
	 { if (n < (size_t)k) n = k; return (n - k);	}

public:

//	 ᪮ 㪠⥫
//	 砫 祭 0. ᫨ 㪠⥫
//	 ᢮ ᪨ ᨢ,
//	  ⪥ 饭  㪠⥫
//	뢠 㭪, ᢮
//	㪠⥫ _exnull_pointer_handler.

  expoint ()    	 	 { a = (exblock<T>*)&__EXNULL; k = 0;	}

//	  ᢠ ᫮
//	祭.  ⫨稥  筮 㪠⥫,
//	᪮ 㪠⥫   
//	८ࠧ ⨯ ᢮  㫥,
//	⠪  㫥 ᫮ 祭.
//	ᨬ  ᫮ 祭
//	 ⪥ 饭  㪠⥫
//	뢠 㭪, ᢮
//	㪠⥫ _exnull_pointer_handler.

  expoint (int i)		 { a = (exblock<T>*)&__EXNULL; k = i;	}

//	  ᢠ ᪮
//	ᨢ ᪮ 㪠⥫.
//	᫥ ᢠ ⠭ 
//	饭  ⠬ ᨢ 
//	⮬᪨ 㢥祭  ࠧ.

  expoint (const exblock<T>&m, int i=0)	{ a = (exblock<T>*)&m; k = i;	}

//	 ஢     㬮砭.
//	樨 ᢠ   ࠧ, ⮡
//	ࠧ ᢠ ⠭ 㪠⥫.

      expoint<T>& operator = (int i)
			{ a = (exblock<T>*)&__EXNULL; k = i;
			  return *this;					}
const expoint<T>& operator = (int i)			const
			{ return *(expoint<T>*)this = i;		}

      expoint<T>& operator = (      exblock<T>& m)
			{ a = &m;  k = 0;   return *this;		}
const expoint<T>& operator = (      exblock<T>& m)	const
			{ return *(expoint<T>*)this = *(exblock<T>*)&m; }
const expoint<T>& operator = (const exblock<T>& m)	const
			{ return *(expoint<T>*)this = *(exblock<T>*)&m; }
#ifdef __TURBOC__
      expoint<T>& operator = (      expoint<T>& m)
			{ a = m.a; k = m.k; return *this;		}
const expoint<T>& operator = (      expoint<T>& m)	const
 			{ return *(expoint<T>*)this = *(expoint<T>*)&m; }
const expoint<T>& operator = (const expoint<T>& m)	const
			{ return *(expoint<T>*)this = *(expoint<T>*)&m; }
#else
      expoint<T>& operator = (const expoint<T>& m)	const
			{ (*(expoint<T>*)this).a = m.a;
			  (*(expoint<T>*)this).k = m.k;
			   return *(expoint<T>*)this;			}
#endif

//	STL-⮤ ࠢ ࠧ஬.

  size_t  size	   ()		const	{ return lf (a->size());	}
  size_t  capacity ()		const	{ return lf (a->capacity());	}
  size_t  max_size ()		const	{ return lf (a->max_size());	}
  int	  empty    ()		const	{ return (size() == 0);		}
  void	  resize   (size_t n)		{ a->resize  (exadd(n,k));	}
                                                                     
//	⨬ࢮ ⮤ ࠢ ࠧ஬.                  
                                                                     
  void	  _chsize  (size_t i)		{ a->_chsize (exadd(i,k));	}
  void	  _chsize  (size_t i, const T **p)
					{ a->_chsize (exadd(i,k),p);	}
  void	  chsize   (size_t i)		{ a->chsize  (exadd(i,k));	}
  void	  chsize   (size_t i, const T **p)
					{ a->chsize  (exadd(i,k),p);	}
  void	  expand   (size_t i)	const	{ a->expand  (exadd(i,k));	}
  void	  expand   (size_t i, const T **p)           
				const	{ a->expand  (exadd(i,k),p);	}
            
//	  ᨢ  ஢ન .
//	뫪    㪠⥫ ⢨⥫
//	  ,  ࠧ ᨢ  .

      T&  item	 (int i)		{ return *(a->base()+k+i);	}
const T&  item	 (int i)	const	{ return *(a->base()+k+i);	}
      T*  base	 ()			{ return  (a->base()+k);	}
const T*  base	 ()		const	{ return  (a->base()+k);	}

//	  ᨢ  ஢મ .
//	 室   ࠭ ᨢ
//	뢠 abort()   㭪,
//	᢮ _exindex_range_handler.

      T&  at     (int i)		{ return  (a->at (k+i));	}
const T&  at     (int i)	const	{ return  (
			      ((const exblock<T>*)a)->at (k+i));	}

//	  ᨢ  ஢મ 
//	 ⮬᪨ 㢥祭 ࠧ.
//	 室   ࠭ ᨢ
//	ࠧ ᨢ ⮬᪨ 㢥稢.
//	 㢥祭 ࠧ ஢ 㫥
//	, ᫥ 祣    ⮢
//	믮   㬮砭.
//	 ᯥ譮 ।  뤠
//	뫪   ᨢ  祭 
//	ᢠ 祭. 뫪 ⢨⥫쭠
//	  ,  ࠧ ᨢ  .

      T&  access (int i)		{ return  (a->access (k+i));	}
const T&  access (int i)	const	{ return  (
			      ((const exblock<T>*)a)->access (k+i));	}

#ifdef	ALLOW_EXARRAY_ITERATORS

//	।  ⥪ STL.
//	᪨ 㪠⥫  㯠 
//	⥩  ࠭祭 ஬ ⮤  
//	業   ந 㯮.

typedef std::random_access_iterator_tag iterator_category;
					// ⥣ .
typedef	      T	 	value_type;	//  .
typedef	   size_t   	size_type;	// size()
typedef	ptrdiff_t	difference_type;// operator -
#ifdef	NCHECKPTR
typedef	      T*  	iterator;	// begin(), end()
typedef	const T*  	const_iterator;	// begin(), end()
#else
typedef	      exptr<T>  iterator;	// begin(), end()
typedef	const exptr<T>	const_iterator;	// begin(), end()
#endif
typedef	      T*	pointer;	// operator ->
typedef	const T*	const_pointer;	// operator ->
typedef       T&	reference;   	// operators *, []
typedef const T&	const_reference;// operators *, []

//	  ⥪ STL.
//        begin	()    뢠  ⥪騩 .
//        end	()    뢠  , ᫥騩
//		       ᫥.
//	᫨ ᪨ 㪠⥫ 室 
//	। ᨢ,  begin() == end().
//	   *end() .
//	 ஫  㯠 ࠭祭
//	㪠⥫, ᯥ稢騩 ஫
//	ᮢ,  ᫨ । 
//	NCHECKPTR -   㪠⥫.
//	 ⢨⥫   ,
//	 ࠧ ᨢ  .

#ifdef	NCHECKPTR

iterator        begin ()	{ return base();	}
const_iterator  begin ()  const	{ return base();	}

iterator        end   ()	{ return base()+size();		}
const_iterator  end   ()  const	{ return base()+size();		}

#else

iterator	begin ()	{ return exptr<T> (*a, k);	}
const_iterator  begin ()  const	{ return exptr<T> (*a, k);	}

iterator	end   ()	{ return exptr<T> (*a, k+size());	}
const_iterator  end   ()  const	{ return exptr<T> (*a, k+size());	}

#endif

#endif//ALLOW_EXARRAY_ITERATORS

//	⮬᪮ ८ࠧ  const T*
//	ਬ  ।  ᨢ
//	 㭪 १ ࠬ const T*  
//	᪨ . ᫨ 㪠⥫
//	᢮ ᪨ ᨢ  㫥
//	᫮ 祭,  ᪮ 祭
//	㪠⥫ - ⨭,  - .
//	᫨  室  ࠭ ᨢ,
//	 ७ ᨢ  ஢.

  operator const T*()	  const	{ return base();	}

//	  ᨢ  ஢મ 
//	 ⮬᪨ 㢥祭 ࠧ.

      T& operator [] (unsigned int i)		{ return (access (i));	}
const T& operator [] (unsigned int i)	const	{ return (access (i));	}
      T& operator [] (int i)			{ return (access (i));	}
const T& operator [] (int i)	  	const	{ return (access (i));	}
      T& operator [] (unsigned short i)		{ return (access (i));	}
const T& operator [] (unsigned short i)	const 	{ return (access (i));	}
      T& operator [] (short i)			{ return (access (i));	}
const T& operator [] (short i)		const	{ return (access (i));	}
      T& operator *  ()		      		{ return (access (0));	}
const T& operator *  ()			const	{ return (access (0));	}
#ifdef	ALLOW_EXARRAY_SELECTION
      T* operator -> ()		      		{ return (T*)(&access (0)); }
const T* operator -> ()			const	{ return (T*)(&access (0)); }
#endif

//	䬥᪨ 樨.

private:

expoint<T> _add (int i)	const	{ return (expoint<T> (*(exblock<T>*)a, k+i));}
expoint<T> _sub (int i)	const	{ return (expoint<T> (*(exblock<T>*)a, k-i));}

expoint<T>& _ad (int i)	const
	   { ((expoint<T>*)this)->k+=i; return (*(expoint<T>*)this);	     }
expoint<T>& _sb (int i)	const
	   { ((expoint<T>*)this)->k-=i; return (*(expoint<T>*)this);	     }
public:

      expoint<T>  operator +  (unsigned int i)		{ return (_add (i)); }
const expoint<T>  operator +  (unsigned int i)	 const	{ return (_add (i)); }
      expoint<T>  operator +  (int i)			{ return (_add (i)); }
const expoint<T>  operator +  (int i)		 const	{ return (_add (i)); }
      expoint<T>  operator +  (unsigned short i)	{ return (_add (i)); }
const expoint<T>  operator +  (unsigned short i) const	{ return (_add (i)); }
      expoint<T>  operator +  (short i)			{ return (_add (i)); }
const expoint<T>  operator +  (short i)		 const	{ return (_add (i)); }

      expoint<T>  operator -  (unsigned int i)		{ return (_sub (i)); }
const expoint<T>  operator -  (unsigned int i)	 const	{ return (_sub (i)); }
      expoint<T>  operator -  (int i)			{ return (_sub (i)); }
const expoint<T>  operator -  (int i)		 const	{ return (_sub (i)); }
      expoint<T>  operator -  (unsigned short i)	{ return (_sub (i)); }
const expoint<T>  operator -  (unsigned short i) const 	{ return (_sub (i)); }
      expoint<T>  operator -  (short i)			{ return (_sub (i)); }
const expoint<T>  operator -  (short i)		 const	{ return (_sub (i)); }

      expoint<T>& operator += (unsigned int i)		{ return (_ad  (i)); }
const expoint<T>& operator += (unsigned int i)	 const	{ return (_ad  (i)); }
      expoint<T>& operator += (int i)			{ return (_ad  (i)); }
const expoint<T>& operator += (int i)		 const	{ return (_ad  (i)); }
      expoint<T>& operator += (unsigned short i)	{ return (_ad  (i)); }
const expoint<T>& operator += (unsigned short i) const	{ return (_ad  (i)); }
      expoint<T>& operator += (short i)			{ return (_ad  (i)); }
const expoint<T>& operator += (short i)		 const	{ return (_ad  (i)); }

      expoint<T>& operator -= (unsigned int i)		{ return (_sb  (i)); }
const expoint<T>& operator -= (unsigned int i)	 const	{ return (_sb  (i)); }
      expoint<T>& operator -= (int i)			{ return (_sb  (i)); }
const expoint<T>& operator -= (int i)		 const	{ return (_sb  (i)); }
      expoint<T>& operator -= (unsigned short i)	{ return (_sb  (i)); }
const expoint<T>& operator -= (unsigned short i) const	{ return (_sb  (i)); }
      expoint<T>& operator -= (short i)			{ return (_sb  (i)); }
const expoint<T>& operator -= (short i)		 const	{ return (_sb  (i)); }
 
      expoint<T>& operator ++ ()	  { k++;  return (*this);	     }
const expoint<T>& operator ++ ()    const { return ++(*((expoint<T>*)this)); }

      expoint<T>& operator -- ()	  { k--;  return (*this);	     } 
const expoint<T>& operator -- ()    const { return --(*((expoint<T>*)this)); }

      expoint<T>  operator ++ (int)	  { expoint<T>t=*this; k++; return t;}
      expoint<T>  operator ++ (int) const { return (*((expoint<T>*)this))++; }

      expoint<T>  operator -- (int)       { expoint<T>t=*this; k--; return t;}
      expoint<T>  operator -- (int) const { return (*((expoint<T>*)this))--; }

private:

//	஢ 権  ᠬ long  char
//	 뤠  ⭮ ⨪.

void	operator [] (unsigned long i)		;
void	operator [] (unsigned long i)	const	;
void	operator [] (long i)			;
void	operator [] (long i)		const	;
void	operator [] (unsigned char i)		;
void	operator [] (unsigned char i)	const	;
void	operator [] (signed char i)		;
void	operator [] (signed char i)	const	;

void	operator +  (unsigned long i)		;
void	operator +  (unsigned long i)	const	;
void	operator +  (long i)			;
void	operator +  (long i)		const	;
void	operator +  (unsigned char i)		;
void	operator +  (unsigned char i)	const	;
void	operator +  (signed char i)		;
void	operator +  (signed char i)	const	;

void	operator -  (unsigned long i)		;
void	operator -  (unsigned long i)	const	;
void	operator -  (long i)			;
void	operator -  (long i)		const	;
void	operator -  (unsigned char i)		;
void	operator -  (unsigned char i)	const	;
void	operator -  (signed char i)		;
void	operator -  (signed char i)	const	;

void	operator += (unsigned long i)		;
void	operator += (unsigned long i)	const	;
void	operator += (long i)			;
void	operator += (long i)		const	;
void	operator += (unsigned char i)		;
void	operator += (unsigned char i)	const	;
void	operator += (signed char i)		;
void	operator += (signed char i)	const	;

void	operator -= (unsigned long i)		;
void	operator -= (unsigned long i)	const	;
void	operator -= (long i)			;
void	operator -= (long i)		const	;
void	operator -= (unsigned char i)		;
void	operator -= (unsigned char i)	const	;
void	operator -= (signed char i)		;
void	operator -= (signed char i)	const	;

#ifdef	ALLOW_EXARRAY_CHARTYPE
void	operator [] (char i)			;
void	operator [] (char i)		const	;
void	operator +  (char i)			;
void	operator +  (char i)		const	;
void	operator -  (char i)			;
void	operator -  (char i)		const	;
void	operator += (char i)			;
void	operator += (char i)		const	;
void	operator -= (char i)			;
void	operator -= (char i)		const	;
#endif
};

//================================================
//	 ࠭祭 㪠⥫.
//================================================

//	࠭祭 㪠⥫ ᮤন ଠ
//	 砫   ᨢ, 
//	ਬ  ஫ 樨
//	 ᬥ饭 ⭮⥫쭮 砫 ᨢ, 
//	஥  室  ࠭ ᨢ,
//	 ⠪   ⥫.
//	⥫쭮 ᬥ饭 ⭮
//	讬 ⥫쭮 ᬥ饭 
//	⥬   .

template <class T> class exptr
{
protected:
  T*		e;	//  ᨢ.
  size_t	len;	// ᫮ ⮢.
  size_t	max;	// ᨬ쭮 ᫮ ⮢
			// (१ࢨ஢).
  int	    	k;	// 饭  ᨢ.
			// ⠭ ᬥ饭.
  size_t  lf    (size_t n)	const
	 { if (n < (size_t)k) n = k; return (n - k);	}

//	뢠 ࠡ ணࠬ.

  T*	  range	(size_t i)	const;

public:

//	 ࠭祭 NULL-㪠⥫.
//	᫨ 㪠⥫  ᢮ ᨢ.
//	  ᪮ 祭 - ,
//	  ⪥ 饭  㪠⥫
//	뢠 㭪, ᢮
//	㪠⥫ _exnull_pointer_handler.

  exptr ()    			{ e = NULL; len = max = 0; k = 0;	}

//	  ᢠ ᫮
//	祭.  ⫨稥  筮 㪠⥫,
//	࠭祭 㪠⥫   
//	८ࠧ ⨯ ᢮  㫥,
//	⠪  㫥 ᫮ 祭.
//	 㫥 ᫮ 祭 ᪮
//	祭 㪠⥫ - ⨭, 
//	 ⪥ 饭  㪠⥫
//	뢠 㭪, ᢮
//	㪠⥫ _exnull_pointer_handler.

  exptr (int i)	{ e = NULL; len = max = 0; k = i;	}

//	  ᢠ 筮
//	ᨢ  㪠⥫ ࠭祭 㪠⥫.
//	᫨ 室 㪠⥫ 㪠⥫ 㫥,
//	 ᫥ ᢠ ᪮ 祭
//	㪠⥫ - ⨭  ⠭
//	 饭  ⠬ ᨢ
//	 ஫ ᮢ.

  exptr (const T* m, size_t n = 1, int i = 0)
		{ if ((e = (T*)m) == NULL) n = 0; len = max = n; k = i;	}

//	  ᢠ ᪮
//	ᨢ  㪠⥫ ࠭祭 㪠⥫.
//	 ᪮ ᨢ   .

  exptr (const exblock<T>&m, int i = 0)
		{ e = (T*) m.base(); len = max = m.size(); k = i;	}
  exptr (const expoint<T>&m, int i = 0)
		{ e = (T*) m.base(); len = max = m.size(); k = i;	}

//	 ஢     㬮砭.
//	樨 ᢠ   ࠧ, ⮡
//	ࠧ ᢠ ⠭ 㪠⥫.

      exptr<T>& operator = (int i)
			{ e = NULL; len = max = 0; k = i;
			  return *this;					}
const exptr<T>& operator = (int i)			const
			{ return *(exptr<T>*)this = i;			}

      exptr<T>& operator = (      exblock<T>& m)
			{ e = m.base(); len = max = m.size();
			  return *this;					}
const exptr<T>& operator = (      exblock<T>& m)	const
			{ return *(exptr<T>*)this = *(exblock<T>*)&m;	}
const exptr<T>& operator = (const exblock<T>& m)	const
			{ return *(exptr<T>*)this = *(exblock<T>*)&m;	}

      exptr<T>& operator = (      expoint<T>& m)
			{ e = m.base(); len = max = m.size();
			  return *this;					}
const exptr<T>& operator = (      expoint<T>& m)	const
			{ return *(exptr<T>*)this = *(expoint<T>*)&m;	}
const exptr<T>& operator = (const expoint<T>& m)	const
			{ return *(exptr<T>*)this = *(expoint<T>*)&m;	}
#ifdef __TURBOC__
      exptr<T>& operator = (      exptr<T>& m)
			{ e = m.e; len = m.len; max = m.max; k = m.k;
			  return *this;					}
const exptr<T>& operator = (      exptr<T>& m)		const
			{ return *(exptr<T>*)this = *(exptr<T>*)&m;	}
const exptr<T>& operator = (const exptr<T>& m)		const
			{ return *(exptr<T>*)this = *(exptr<T>*)&m;	}
#else
      exptr<T>& operator = (const exptr<T>& m)		const
			{ (*(exptr<T>*)this).e   = m.e;
			  (*(exptr<T>*)this).len = m.len;
			  (*(exptr<T>*)this).max = m.max;
			  (*(exptr<T>*)this).k   = m.k;
			  return *(exptr<T>*)this;								}
#endif

//	  ᨢ  ஢ન .

      T&  item   (int i)		{ return *(e+k+i);	}
const T&  item   (int i)	const	{ return *(e+k+i);	}
      T*  base   ()			{ return  (e+k);	}
const T*  base   ()		const	{ return  (e+k);	}

//	  ᨢ  ஢મ .

private:

#ifdef	ALLOW_EXARRAY_SHEDULING

      T&  _at	(int i)
	{ register T* p = e; if (len <= (size_t)i) p = range(i); return p[i]; }
const T&  _at	(int i)	const
  { const register T* p = e; if (len <= (size_t)i) p = range(i); return p[i]; }

#else //ALLOW_EXARRAY_SHEDULING

      T& _at	 (int i)		
		{ if (len <= (size_t)i) range (i); return e[i];	}
const T& _at	 (int i)	const
		{ if (len <= (size_t)i) range (i); return e[i];	}

#endif//ALLOW_EXARRAY_SHEDULING

public:

      T&  at     (int i)	 	{ return (_at (k+i));	}
const T&  at     (int i)	const	{ return (_at (k+i));	}

#ifdef	ALLOW_EXARRAY_ITERATORS

//	।  ⥪ STL.
//	࠭祭 㪠⥫  㯠 
//	⥩  ࠭祭 ஬ 㭪権  
//	業   ந 㯮.

typedef std::random_access_iterator_tag iterator_category;
					// ⥣ .
typedef	      T	 	value_type;	//  .
typedef	   size_t   	size_type;	// size()
typedef	ptrdiff_t	difference_type;// operator -
#ifdef	NCHECKPTR
typedef	      T*  	iterator;	// begin(), end()
typedef	const T*  	const_iterator;	// begin(), end()
#else
typedef	      exptr<T>  iterator;	// begin(), end()
typedef	const exptr<T>	const_iterator;	// begin(), end()
#endif
typedef	      T*	pointer;	// operator ->
typedef	const T*	const_pointer;	// operator ->
typedef       T&	reference;   	// operators *, []
typedef const T&	const_reference;// operators *, []

//	  ⥪ STL.
//        begin	()    뢠  ⥪騩 .
//        end	()    뢠  , ᫥騩
//		       ᫥.
//	᫨ ࠭祭 㪠⥫ 室 
//	। ᨢ,  begin() == end().
//	   *end() .

#ifdef	NCHECKPTR

iterator        begin ()	{ return base();	}
const_iterator  begin ()  const	{ return base();	}

iterator        end   ()	{ return base()+size();	}
const_iterator  end   ()  const	{ return base()+size();	}

#else

iterator	begin ()	{ return *this;		}
const_iterator  begin ()  const	{ return *this;		}

iterator	end   ()	{ return exptr<T>(e,k,(len<(size_t)k?k:len));}
const_iterator  end   ()  const	{ return exptr<T>(e,k,(len<(size_t)k?k:len));}

#endif

#endif//ALLOW_EXARRAY_ITERATORS

//	⮬᪮ ८ࠧ  const T*
//	ਬ  ।  ᨢ
//	 㭪 १ ࠬ const T*  
//	᪨ . ᫨ 㪠⥫
//	᢮ ᪨ ᨢ  㫥
//	᫮ 祭,  ᪮ 祭
//	㪠⥫ - ⨭,  - .

  operator const T*()	  const	{ return base();	}

//	  ᨢ  ஢મ .

      T& operator [] (unsigned int i)		{ return (at (i));	}
const T& operator [] (unsigned int i)	const	{ return (at (i));	}
      T& operator [] (int i)			{ return (at (i));	}
const T& operator [] (int i)	  	const	{ return (at (i));	}
      T& operator [] (unsigned short i)		{ return (at (i));	}
const T& operator [] (unsigned short i) const 	{ return (at (i));	}
      T& operator [] (short i)			{ return (at (i));	}
const T& operator [] (short i)		const	{ return (at (i));	}
      T& operator *  ()		      		{ return (at (0));	}
const T& operator *  ()			const	{ return (at (0));	}
#ifdef	ALLOW_EXARRAY_SELECTION
      T* operator -> ()		      		{ return (T*)(&at (0));	}
const T* operator -> ()			const	{ return (T*)(&at (0));	}
#endif

//	䬥᪨ 樨.

private:

exptr<T>   _add (int i)	const	{ return (exptr<T> ((T*)e, len, k+i));  }
exptr<T>   _sub (int i)	const	{ return (exptr<T> ((T*)e, len, k-i));  }

exptr<T>&  _ad  (int i)	const
        	{ ((exptr<T>*)this)->k+=i; return (*(exptr<T>*)this);	}
exptr<T>&  _sb  (int i)	const
		{ ((exptr<T>*)this)->k-=i; return (*(exptr<T>*)this);	}
public:

      exptr<T>    operator +  (unsigned int i)		{ return (_add (i)); }
const exptr<T>    operator +  (unsigned int i)	 const	{ return (_add (i)); }
      exptr<T>    operator +  (int i)			{ return (_add (i)); }
const exptr<T>    operator +  (int i)		 const	{ return (_add (i)); }
      exptr<T>    operator +  (unsigned short i)	{ return (_add (i)); }
const exptr<T>    operator +  (unsigned short i) const	{ return (_add (i)); }
      exptr<T>    operator +  (short i)			{ return (_add (i)); }
const exptr<T>    operator +  (short i)		 const	{ return (_add (i)); }

      exptr<T>    operator -  (unsigned int i)		{ return (_sub (i)); }
const exptr<T>    operator -  (unsigned int i)	 const	{ return (_sub (i)); }
      exptr<T>    operator -  (int i)			{ return (_sub (i)); }
const exptr<T>    operator -  (int i)		 const	{ return (_sub (i)); }
      exptr<T>    operator -  (unsigned short i)	{ return (_sub (i)); }
const exptr<T>    operator -  (unsigned short i) const 	{ return (_sub (i)); }
      exptr<T>    operator -  (short i)			{ return (_sub (i)); }
const exptr<T>    operator -  (short i)		 const	{ return (_sub (i)); }

      exptr<T>&   operator += (unsigned int i)		{ return (_ad  (i)); }
const exptr<T>&   operator += (unsigned int i)	 const	{ return (_ad  (i)); }
      exptr<T>&   operator += (int i)			{ return (_ad  (i)); }
const exptr<T>&   operator += (int i)		 const	{ return (_ad  (i)); }
      exptr<T>&   operator += (unsigned short i)	{ return (_ad  (i)); }
const exptr<T>&   operator += (unsigned short i) const	{ return (_ad  (i)); }
      exptr<T>&   operator += (short i)			{ return (_ad  (i)); }
const exptr<T>&   operator += (short i)		 const	{ return (_ad  (i)); }

      exptr<T>&   operator -= (unsigned int i)		{ return (_sb  (i)); }
const exptr<T>&   operator -= (unsigned int i)	 const	{ return (_sb  (i)); }
      exptr<T>&   operator -= (int i)			{ return (_sb  (i)); }
const exptr<T>&   operator -= (int i)		 const	{ return (_sb  (i)); }
      exptr<T>&   operator -= (unsigned short i)	{ return (_sb  (i)); }
const exptr<T>&   operator -= (unsigned short i) const	{ return (_sb  (i)); }
      exptr<T>&   operator -= (short i)			{ return (_sb  (i)); }
const exptr<T>&   operator -= (short i)		 const	{ return (_sb  (i)); }
 
      exptr<T>&   operator ++ ()	  { k++;  return (*this);	     }
const exptr<T>&   operator ++ ()    const { return ++(*((exptr<T>*)this));   }

      exptr<T>&   operator -- ()	  { k--;  return (*this);	     }
const exptr<T>&   operator -- ()    const { return --(*((exptr<T>*)this));   }

      exptr<T>    operator ++ (int)	  { exptr<T>t=*this; k++; return t;  }
      exptr<T>    operator ++ (int) const { return (*((exptr<T>*)this))++;   }

      exptr<T>    operator -- (int)       { exptr<T>t=*this; k--; return t;  }
      exptr<T>    operator -- (int) const { return (*((exptr<T>*)this))--;   }

private:

//	஢ 権  ᠬ long  char
//	 뤠  ⭮ ⨪.

void	operator [] (unsigned long i)		;
void	operator [] (unsigned long i)	const	;
void	operator [] (long i)			;
void	operator [] (long i)		const	;
void	operator [] (unsigned char i)		;
void	operator [] (unsigned char i)	const	;
void	operator [] (signed char i)		;
void	operator [] (signed char i)	const	;

void	operator +  (unsigned long i)		;
void	operator +  (unsigned long i)	const	;
void	operator +  (long i)			;
void	operator +  (long i)		const	;
void	operator +  (unsigned char i)		;
void	operator +  (unsigned char i)	const	;
void	operator +  (signed char i)		;
void	operator +  (signed char i)	const	;

void	operator -  (unsigned long i)		;
void	operator -  (unsigned long i)	const	;
void	operator -  (long i)			;
void	operator -  (long i)		const	;
void	operator -  (unsigned char i)		;
void	operator -  (unsigned char i)	const	;
void	operator -  (signed char i)		;
void	operator -  (signed char i)	const	;

void	operator += (unsigned long i)		;
void	operator += (unsigned long i)	const	;
void	operator += (long i)			;
void	operator += (long i)		const	;
void	operator += (unsigned char i)		;
void	operator += (unsigned char i)	const	;
void	operator += (signed char i)		;
void	operator += (signed char i)	const	;

void	operator -= (unsigned long i)		;
void	operator -= (unsigned long i)	const	;
void	operator -= (long i)			;
void	operator -= (long i)		const	;
void	operator -= (unsigned char i)		;
void	operator -= (unsigned char i)	const	;
void	operator -= (signed char i)		;
void	operator -= (signed char i)	const	;

#ifdef	ALLOW_EXARRAY_CHARTYPE
void	operator [] (char i)			;
void	operator [] (char i)		const	;
void	operator +  (char i)			;
void	operator +  (char i)		const	;
void	operator -  (char i)			;
void	operator -  (char i)		const	;
void	operator += (char i)			;
void	operator += (char i)		const	;
void	operator -= (char i)			;
void	operator -= (char i)		const	;
#endif
};

//	饭 ⮤ range (i) 뢠
//	 饭    i >= len
//	 뢠 ࠡ ணࠬ.

template <class T> T* exptr<T>::range (size_t /*i*/) const
{
  if (e == NULL)
	(*_exnull_pointer_handler)();
  else	(*_exindex_range_handler)();
  return (e);
};

//================================================
//	  ࣠樨 ஫ ᮢ
//	 ⫠.
//================================================

//	EXPTR(T)	-  ⫠筮 㪠⥫ 
//			  ᨢ ⮢ ⨯ T.
//	EXPTRTO(T,m,n)	- ନ஢ ⫠筮 㪠⥫ 
//			   ᨢ m  n ⮢ ⨯ T.
//	EXPTRTYPE(m)	- ८ࠧ ᪮ ᨢ,
//			  ᪮  ࠭祭
//			  㪠⥫  ଠ, ᪠騩
//			  ᢠ ⫠筮 㪠⥫. 
//	EXPTRBASE(p)	- ८ࠧ ⫠筮 㪠⥫
//			   筮 㪠⥫  ஫ ᮢ.
//	஫ ᮢ  ⫠ 㪠⥫
//	஢  ⢨  NCHECKPTR.
//	ਬ:			 ஫ ᮢ.	 ஫ ᮢ.	
//	int m1 [10];
//	exarray<int> m2;
//	EXPTR(int) p;		exptr<int> p;		int* p;
//	p = EXPTRTO(m1,10);	p = exptr<int>(m1,10);	p = m1;
//	p = EXPTRTYPE(m2);	p = m2;			p = m2.base();
//	EXPTRBASE(p);		p.base();		p;

#ifdef	NCHECKPTR

#define EXPTR(T)	T*
#define	EXPTRTO(T,m,n)	(m)
#define EXPTRTYPE(m)	((m).base())
#define EXPTRBASE(p)	(p)

#else

#define EXPTR(T)	exptr<T>
#define	EXPTRTO(T,m,n)	(exptr<T>(m,n));
#define EXPTRTYPE(m)	(m)
#define EXPTRBASE(p)	((p).base())

#endif

//================================================
//	 権 ࠢ.
//================================================

template <class T> inline int	operator == (const exarray<T>& t, const exarray<T>& m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const exarray<T>& t, const exarray<T>& m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const exarray<T>& t, const exarray<T>& m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const exarray<T>& t, const exarray<T>& m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const exarray<T>& t, const exarray<T>& m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const exarray<T>& t, const exarray<T>& m) { return (t.base() >= m.base()); };

template <class T> inline int	operator == (const exarray<T>& t, const expoint<T>& m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const exarray<T>& t, const expoint<T>& m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const exarray<T>& t, const expoint<T>& m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const exarray<T>& t, const expoint<T>& m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const exarray<T>& t, const expoint<T>& m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const exarray<T>& t, const expoint<T>& m) { return (t.base() >= m.base()); };

template <class T> inline int	operator == (const exarray<T>& t, const exptr<T>&   m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const exarray<T>& t, const exptr<T>&   m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const exarray<T>& t, const exptr<T>&   m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const exarray<T>& t, const exptr<T>&   m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const exarray<T>& t, const exptr<T>&   m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const exarray<T>& t, const exptr<T>&   m) { return (t.base() >= m.base()); };

template <class T> inline int	operator == (const expoint<T>& t, const exarray<T>& m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const expoint<T>& t, const exarray<T>& m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const expoint<T>& t, const exarray<T>& m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const expoint<T>& t, const exarray<T>& m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const expoint<T>& t, const exarray<T>& m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const expoint<T>& t, const exarray<T>& m) { return (t.base() >= m.base()); };

template <class T> inline int	operator == (const expoint<T>& t, const expoint<T>& m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const expoint<T>& t, const expoint<T>& m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const expoint<T>& t, const expoint<T>& m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const expoint<T>& t, const expoint<T>& m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const expoint<T>& t, const expoint<T>& m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const expoint<T>& t, const expoint<T>& m) { return (t.base() >= m.base()); };

template <class T> inline int	operator == (const expoint<T>& t, const exptr<T>&   m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const expoint<T>& t, const exptr<T>&   m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const expoint<T>& t, const exptr<T>&   m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const expoint<T>& t, const exptr<T>&   m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const expoint<T>& t, const exptr<T>&   m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const expoint<T>& t, const exptr<T>&   m) { return (t.base() >= m.base()); };

template <class T> inline int	operator == (const exptr<T>&   t, const exarray<T>& m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const exptr<T>&   t, const exarray<T>& m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const exptr<T>&   t, const exarray<T>& m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const exptr<T>&   t, const exarray<T>& m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const exptr<T>&   t, const exarray<T>& m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const exptr<T>&   t, const exarray<T>& m) { return (t.base() >= m.base()); };

template <class T> inline int	operator == (const exptr<T>&   t, const expoint<T>& m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const exptr<T>&   t, const expoint<T>& m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const exptr<T>&   t, const expoint<T>& m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const exptr<T>&   t, const expoint<T>& m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const exptr<T>&   t, const expoint<T>& m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const exptr<T>&   t, const expoint<T>& m) { return (t.base() >= m.base()); };

template <class T> inline int	operator == (const exptr<T>&   t, const exptr<T>&   m) { return (t.base() == m.base()); };
template <class T> inline int	operator != (const exptr<T>&   t, const exptr<T>&   m) { return (t.base() != m.base()); };
template <class T> inline int	operator <  (const exptr<T>&   t, const exptr<T>&   m) { return (t.base() <  m.base()); };
template <class T> inline int	operator >  (const exptr<T>&   t, const exptr<T>&   m) { return (t.base() >  m.base()); };
template <class T> inline int	operator <= (const exptr<T>&   t, const exptr<T>&   m) { return (t.base() <= m.base()); };
template <class T> inline int	operator >= (const exptr<T>&   t, const exptr<T>&   m) { return (t.base() >= m.base()); };

//================================================
//	 権 ⠭.
//================================================

template <class T> inline ptrdiff_t operator - (const exarray<T>& t, const exarray<T>& m) { return (t.base() - m.base()); };
template <class T> inline ptrdiff_t operator - (const exarray<T>& t, const expoint<T>& m) { return (t.base() - m.base()); };
template <class T> inline ptrdiff_t operator - (const exarray<T>& t, const exptr<T>&   m) { return (t.base() - m.base()); };

template <class T> inline ptrdiff_t operator - (const expoint<T>& t, const exarray<T>& m) { return (t.base() - m.base()); };
template <class T> inline ptrdiff_t operator - (const expoint<T>& t, const expoint<T>& m) { return (t.base() - m.base()); };
template <class T> inline ptrdiff_t operator - (const expoint<T>& t, const exptr<T>&   m) { return (t.base() - m.base()); };

template <class T> inline ptrdiff_t operator - (const exptr<T>&   t, const exarray<T>& m) { return (t.base() - m.base()); };
template <class T> inline ptrdiff_t operator - (const exptr<T>&   t, const expoint<T>& m) { return (t.base() - m.base()); };
template <class T> inline ptrdiff_t operator - (const exptr<T>&   t, const exptr<T>&   m) { return (t.base() - m.base()); };

//================================================
//	 ⥪ ᨢ  ६묨
//	ࠧࠬ.
//================================================

//	 뢠 ⥪, 㤠   (get)
//	ᨢ exblock<T>  㤠   (put)
//	ᨢ exblock<T>, ᫨    㦥.
//	⮤ get  put  ਬ  
//	  ꥪ⮢, ந  蠡 exblock
//	 ࠡ ॥  ⮤ । .

template <class T> class exblockstack
{
  exarray<__exblock> stack;	// ⥪ ᨢ exblock<T>.
  size_t n;			// ᫮ ᨢ.

//	 ஢ ᢠ ⥪
//	 ਢ 
//	஢   ᢠ.

  exblockstack		      (const exblockstack<T>&);
  exblockstack<T>& operator = (const exblockstack<T>&);
                                	
public:

//	 ᮧ ⮩ ⥪.
                                
  exblockstack()	{ n = 0;    }	// .

  void get (exblock<T>&);		// 祭 ᨢ.
  void put (exblock<T>&);		// ᥭ ᨢ.
  size_t size () const { return n; }	// ᫮ ᨢ.

 ~exblockstack();			// .
};

//	⮤ get  ᨢ  ⥪,
//	 ᫨ ⥪  -  ᮧ ⮩
//	ᨢ exblock<T>.

template <class T> void exblockstack<T>::get (exblock<T>& array)
{
  if (n)				// ⥪  -
  {    					// 祭 ᨢ.
    exblock<T>* p = (exblock<T>*) & (stack.item (--n));
    array._setbase (p->base()); p->_setbase (NULL);
    array._setsize (p->size()); p->_setsize (0);
  }
  else					// ⥪  - 
  {					// ᮧ ᨢ.
    array._setbase (NULL);
    array._setsize (0);
  }
};

//	⮤ put  ᨢ  ⥪.

template <class T> void exblockstack<T>::put (exblock<T>& array)
{
  exblock<T>* p = (exblock<T>*) & (stack [n++]);
  p->_setbase (array.base()); array._setbase (NULL);
  p->_setsize (array.size()); array._setsize (0);
};

//	 㤠  室騥
//	 ⥪ ᪨ ᨢ.

template <class T> exblockstack<T>::~exblockstack()
{
  while (n) ((exblock<T>*) & (stack.item (--n)))->clear();
};

//================================================
//	 ப 㭪権 
//	᪨ ᨢ ⨯ char.
//================================================

#ifdef	ALLOW_EXARRAY_STRING

//	८। 㭪権  string.h
//	 ᯮ짮  㭪樨 
//	᪨ ᨢ  㪠⥫ <char>.
//
//	᪮ ᪨ ᨢ  㪠⥫
//	⮬᪨ ८ࠧ  ⠭
//	㪠⥫,  ८। ॡ
//	⮫쪮 㭪樨, 騥  
//	᪨ ᨢ.
//
//	८। ࠦ  
//	஢, ࠢ ࠧ஬ ᨢ.

#include<string.h>

//	室 訡  Borland C++ (Release mode)
#ifdef	__TURBOC__
#pragma warn -ill
#pragma intrinsic -memcpy
#pragma intrinsic -memmove
#pragma intrinsic -memset
#pragma intrinsic -strcpy
#pragma intrinsic -strcat
#pragma intrinsic -stpcpy
#pragma intrinsic -strncpy
#pragma intrinsic -strncat
#pragma intrinsic -strxfrm
#pragma intrinsic -memccpy
#pragma intrinsic -strset
#pragma intrinsic -strnset
#pragma warn .ill
#endif//__TURBOC__

inline	expoint<char>
memcpy  (expoint<char> __dest, const void* __src, size_t __n)
{
  __dest.expand (__n, (const char**)&__src);
  memcpy (__dest.base(), __src, __n);
  return (__dest);
}
inline	exarray<char>&
memcpy  (exarray<char>&__dest, const void* __src, size_t __n)
{
  __dest.expand (__n, (const char**)&__src);
  memcpy (__dest.base(), __src, __n);
  return (__dest);
}

inline	expoint<char>
memmove (expoint<char> __dest, const void* __src, size_t __n)
{
  __dest.expand (__n, (const char**)&__src);
  memmove (__dest.base(), __src, __n);
  return (__dest);
}
inline	exarray<char>&
memmove (exarray<char>&__dest, const void* __src, size_t __n)
{
  __dest.expand (__n, (const char**)&__src);
  memmove (__dest.base(), __src, __n);
  return (__dest);
}

inline	expoint<char>
memset  (expoint<char> __s, int __c, size_t __n)
{
  __s.expand (__n);
  memset (__s.base(), __c, __n);
  return (__s);
}
inline	exarray<char>&
memset  (exarray<char>&__s, int __c, size_t __n)
{
  __s.expand (__n);
  memset (__s.base(), __c, __n);
  return (__s);
}

inline	expoint<char>
strcpy	(expoint<char> __dest, const char* __src)
{
  return (memcpy (__dest, __src, strlen (__src) + 1));
}
inline	exarray<char>&
strcpy	(exarray<char>&__dest, const char* __src)
{
  return (memcpy (__dest, __src, strlen (__src) + 1));
}

inline	expoint<char>
strcat	(expoint<char> __dest, const char* __src)
{
  expoint<char> pdest (__dest);
  strcpy (pdest += strlen (__dest), __src);
  return (__dest);
}
inline	exarray<char>&
strcat	(exarray<char>&__dest, const char* __src)
{
  expoint<char> pdest (__dest);
  strcpy (pdest += strlen (__dest), __src);
  return (__dest);
}

inline	expoint<char>
stpcpy	(expoint<char> __dest, const char* __src)
{
  return (strcpy(__dest, __src) + strlen (__src));
}
inline	expoint<char>
stpcpy	(exarray<char>&__dest, const char* __src)
{
  return (expoint<char>(strcpy(__dest, __src), strlen (__src)));
}

inline	expoint<char>
strncpy (expoint<char> __dest, const char* __src, size_t __maxlen)
{
  __dest.expand (__maxlen, &__src);
  strncpy (__dest.base(), __src, __maxlen);
  return (__dest);
}
inline	exarray<char>&
strncpy (exarray<char>&__dest, const char* __src, size_t __maxlen)
{
  __dest.expand (__maxlen, &__src);
  strncpy (__dest.base(), __src, __maxlen);
  return (__dest);
}

inline	expoint<char>
strncat	(expoint<char> __dest, const char* __src, size_t __maxlen)
{
  __dest.expand (exadd (strlen (__dest) + 1, __maxlen), &__src);
  strncat (__dest.base(), __src, __maxlen);
  return (__dest);
}
inline	exarray<char>&
strncat	(exarray<char>&__dest, const char* __src, size_t __maxlen)
{
  __dest.expand (exadd (strlen (__dest) + 1, __maxlen), &__src);
  strncat (__dest.base(), __src, __maxlen);
  return (__dest);
}

inline	size_t
strxfrm (expoint<char> __dest, const char* __src, size_t __maxlen)
{
  __dest.expand (__maxlen);
  return (strxfrm (__dest.base(), __src, __maxlen));
}
inline	size_t
strxfrm (exarray<char>&__dest, const char* __src, size_t __maxlen)
{
  __dest.expand (__maxlen);
  return (strxfrm (__dest.base(), __src, __maxlen));
}

#ifndef	__STDC__

inline	expoint<char>
memccpy (expoint<char> __dest, const void* __src, int __c, size_t __n)
{
  __dest.expand (__n, (const char**)&__src);
  char* p = (char*) memccpy (__dest.base(),__src, __c, __n);
  expoint<char> pdest;
  if (p) { pdest = __dest; pdest += ((size_t)p - (size_t)__dest.base()); }
  return (pdest);
}
inline	expoint<char>
memccpy (exarray<char>&__dest, const void* __src, int __c, size_t __n)
{
  __dest.expand (__n, (const char**)&__src);
  char* p = (char*) memccpy (__dest.base(),__src, __c, __n);
  expoint<char> pdest;
  if (p) { pdest = __dest; pdest += ((size_t)p - (size_t)__dest.base()); }
  return (pdest);
}

inline	expoint<char>
strnset	(expoint<char> __s, int __ch, size_t __n)
{
  __s.expand (__n);
  strnset (__s.base(), __ch, __n);
  return (__s);
}
inline	exarray<char>&
strnset	(exarray<char>&__s, int __ch, size_t __n)
{
  __s.expand (__n);
  strnset (__s.base(), __ch, __n);
  return (__s);
}

inline	expoint<char>
strset	(expoint<char> __s, int __ch)
{
  strnset (__s.base(), __ch, __s.size());
  return (__s);
}
inline	exarray<char>&
strset	(exarray<char>&__s, int __ch)
{
  strnset (__s.base(), __ch, __s.size());
  return (__s);
}

#endif//__STDC__

#endif//ALLOW_EXARRAY_STRING

#endif//_EXARRAY_H
