/*	exio.h

	-뢮  ࠡ⪮ 訡.
		
	(C) ..஢,   PAH, 1992 - 1999
	All Rights Reserved.
*/
#ifndef _EXIO_H
#define _EXIO_H

#include <fcntl.h>		//   䠩.

#ifndef _EXDEF_H
#include <exdef.h>
#endif

#ifndef	SEEK_SET		// 樮஢ ( exlseek).
#define	SEEK_SET	0	//  砫 䠩.
#define SEEK_CUR	1	//  ⥪饩 樨.
#define	SEEK_END	2	//   䠩.
#endif

#define EXCR	'\r'		// C  ⪨ (MS DOS).
#define EXEOL	'\n'		// C  ப.
#define EXEOF	'\x1A'		// C  䠩.

#if	defined	(__TINY__) || defined (__SMALL__) || defined (__MEDIUM__)
#define EXGET_SIZE	2048	// 㥬 ࠧ  ⥭.
#define EXPUT_SIZE	2048	// 㥬 ࠧ  .
#else
#define EXGET_SIZE	8192	// 㥬 ࠧ  ⥭.
#define EXPUT_SIZE	2048	// 㥬 ࠧ  .
#endif

#ifdef __cplusplus
extern "C" {
#endif

// =========================================================================
//	  - 뢮.
// =========================================================================

int	STDECL	exopen	(const char *path, int access);	// ⨥ 䠩.
//    ⠭⠬  fcntl.h; ४
//  (? -  b  筮 ०  t  ⥪⮢):
//	exopen?r   (const char *path);		//   ⥭.
//	exopen?rw  (const char *path);		//   ⥭  .
//	exopen?    (const char *path);		//   ᮧ.
//	exopen?e   (const char *path);		//   ࠭.
//	exopen?a   (const char *path);		//   .
//	exopen?wr  (const char *path);		//     ⥭.
//	exopen?w   (const char *path);		//   .
// 뤠 ਯ fd;  㤠 뢠 䨪⨢ 䠩  fd < 0.
int	STDECL	exdup   (int fd);		// 㡫஢ fd.
void	STDECL	exdup2  (int fd, int newfd);	// 㡫஢ fd -> newfd.
int	STDECL	exread	(int fd, void *buf, size_t len);// ⥭.
int	STDECL	_exread	(int fd, void *buf, size_t len);// ⥭  ⪨.
int	STDECL	exwrite	(int fd, const void *buf, size_t len);	// .
void	STDECL	extrunc	(int fd);			// 祭.
long	STDECL	exlseek	(int fd, long offset, int from);// 樮஢.
long	STDECL	exltell	(int fd);			//  .
long	STDECL	exlsize	(int fd);			//  䠩.
void	STDECL	exltrunc(int fd, long offset, int from);// 祭 (excatch).
void	STDECL	exclose	(int fd);			// ⨥ (excatch).

#define	exopenbr(path)	exopen (path, O_RDONLY | O_BINARY)
#define	exopenbrw(path)	exopen (path, O_RDWR   | O_BINARY)
#define	exopenb(path)	exopen (path, O_RDWR   | O_BINARY | O_CREAT)
#define	exopenbe(path)	exopen (path, O_RDWR   | O_BINARY | O_CREAT | O_EXCL)
#define	exopenba(path)	exopen (path, O_RDWR   | O_BINARY | O_CREAT | O_APPEND)
#define	exopenbwr(path)	exopen (path, O_RDWR   | O_BINARY | O_CREAT | O_TRUNC)
#define	exopenbw(path)	exopen (path, O_WRONLY | O_BINARY | O_CREAT | O_TRUNC)
#define	exopentr(path)	exopen (path, O_RDONLY | O_TEXT)
#define	exopentrw(path)	exopen (path, O_RDWR   | O_TEXT)
#define	exopent(path)	exopen (path, O_RDWR   | O_TEXT | O_CREAT)
#define	exopente(path)	exopen (path, O_RDWR   | O_TEXT | O_CREAT | O_EXCL)
#define	exopenta(path)	exopen (path, O_RDWR   | O_TEXT | O_CREAT | O_APPEND)
#define	exopentwr(path)	exopen (path, O_RDWR   | O_TEXT | O_CREAT | O_TRUNC)
#define	exopentw(path)	exopen (path, O_WRONLY | O_TEXT | O_CREAT | O_TRUNC)
#define	exltell(fd)	exlseek	(fd, 0L, SEEK_CUR)

// =========================================================================
//	 樨.
// =========================================================================

extern	int	VDECL	extime;		// ⬥ ஢ ६ 
					// ஢  ६饭 䠩.
int	STDECL	excompare   (const char *src, const char *dst);	// ࠢ.
int	STDECL	excomparing (const char *src, const char *dst);	// + .
void	STDECL	excopy	    (const char *src, const char *dst);	// ஢.
void	STDECL	excopying   (const char *src, const char *dst);	// + .
int	STDECL	excopcmp    (const char *src, const char *dst);	// + ࠢ.
void	STDECL	exrename    (const char *src, const char *dst);	// ६饭.
void	STDECL	exrenaming  (const char *src, const char *dst);	// + .
int	STDECL	exrencmp    (const char *src, const char *dst);	// + ࠢ.
void	STDECL	exremove    (const char *path);		       	// .
void	STDECL	exunlink    (const char *path);		       	// + excatch.
//	㭪樨, ॡ騥 ⠭   ᪮७ ࠡ.
void	STDECL	exsetbuf    (void *buf, size_t size);		// .
int	STDECL	_excompare  (const char *src, const char *dst);	// ࠢ.
int	STDECL	_excomparing(const char *src, const char *dst);	// + .
void	STDECL	_excopy	    (const char *src, const char *dst);	// ஢.
void	STDECL	_excopying  (const char *src, const char *dst);	// + .
int	STDECL	_excopcmp   (const char *src, const char *dst);	// + ࠢ.
void	STDECL	_exrename   (const char *src, const char *dst);	// ६饭.
void	STDECL	_exrenaming (const char *src, const char *dst);	// + .
int	STDECL	_exrencmp   (const char *src, const char *dst);	// + ࠢ.
//	맮 㬥⭮ 㭪樨  ⠭ .
int	STDECL	_exbuf2  (const char *src, const char *dst, FCMP func);

#define			__EXBUFSIZE	32	//  讣 .
extern	char	VDECL	__EXBUF [__EXBUFSIZE];	// 让 .
extern	size_t	VDECL	_exbufsize;		//  .
extern	char*	VDECL	_exbuf;			// ⥫ .

#define	exsetbuf(buf,size)	  (_exbuf = (buf), _exbufsize = (size))
#define	excompare(src,dst)	  (_exbuf2 (src, dst, (FCMP)_excompare))
#define	excomparing(src,dst)	  (_exbuf2 (src, dst, (FCMP)_excomparing))
#define	excopy(src,dst)	    ((void)_exbuf2 (src, dst, (FCMP)_excopy))
#define	excopying(src,dst)  ((void)_exbuf2 (src, dst, (FCMP)_excopying))
#define	excopcmp(src,dst)	  (_exbuf2 (src, dst, (FCMP)_excopcmp))
#define	exrename(src,dst)   ((void)_exbuf2 (src, dst, (FCMP)_exrename))
#define	exrenaming(src,dst) ((void)_exbuf2 (src, dst, (FCMP)_exrenaming))
#define	exrencmp(src,dst)	  (_exbuf2 (src, dst, (FCMP)_exrencmp))
	
// =========================================================================
//	.
// =========================================================================
#ifdef	__FLAT__
#ifndef _FFBLK_DEF
#define _FFBLK_DEF
struct  ffblk   {
#ifdef	__TURBOC__
    long            ff_reserved;
    long            ff_fsize;
    unsigned long   ff_attrib;
    unsigned short  ff_ftime;
    unsigned short  ff_fdate;
    char            ff_name[256];
#else//	__TURBOC__
    unsigned long   ff_attrib;
    unsigned short  ff_ftime_create;	/* -1 for FAT file systems */
    unsigned short  ff_fdate_create;	/* -1 for FAT file systems */
    unsigned short  ff_ftime_access;	/* -1 for FAT file systems */
    unsigned short  ff_fdate_access;	/* -1 for FAT file systems */
    unsigned short  ff_ftime;
    unsigned short  ff_fdate;
    unsigned long   ff_fsize;
    char	    ff_name[260];
    long	    _ff_fd;
    unsigned long   _ff_attrib;
#endif//__TURBOC__
};
#endif//_FFBLK_DEF

#define MAXPATH   260
#define MAXDIR    256
#define MAXFILE   256
#define MAXEXT    256
#define	MAXNAME	  256

#else//__FLAT__

#ifndef _FFBLK_DEF
#define _FFBLK_DEF
struct  ffblk   {
    char        ff_reserved[21];
    char        ff_attrib;
    unsigned    ff_ftime;
    unsigned    ff_fdate;
    long        ff_fsize;
    char        ff_name[13];
};
#endif//_FFBLK_DEF
#define MAXPATH   80
#define MAXDIR	  66
#define MAXFILE   9
#define MAXEXT	  5
#define	MAXNAME	(MAXFILE + MAXEXT - 1)

#endif//__FLAT__

#define MAXDRIVE  3
#define	FFBLK	struct ffblk

#ifndef FA_RDONLY		/* ff_attrib */
#define FA_NORMAL   0x00        /* Normal file, no attributes */
#define FA_RDONLY   0x01        /* Read only attribute */
#define FA_HIDDEN   0x02        /* Hidden file */
#define FA_SYSTEM   0x04        /* System file */
#define FA_LABEL    0x08        /* Volume label */
#define FA_DIREC    0x10        /* Directory */
#define FA_ARCH     0x20        /* Archive */
#endif

#ifndef	__TURBOC__
void	STDECL	getftime (int fd, struct ftime *ft);
void	STDECL	setftime (int fd, struct ftime *ft);
struct  ftime   {
	long	ft_time;
};
#endif

int	STDECL	exfindfirst (const char *path, FFBLK* ff, int atr); // .
int	STDECL	exfindnext  (FFBLK* ff);		// த ᪠.
int	STDECL	exfindcomp  (FFBLK* ff, int atr);	// ࠢ ਡ⮢.
void	STDECL	exfindclose (FFBLK* ff);		// 襭 ᪠.
void	STDECL	exchmod	    (const char *path, int atr);// ⠭ ਡ⮢.
void	STDECL	exmkdir	    (const char *path);		//  ⠫.
void	STDECL	exrmdir	    (const char *path);		//  ⠫.
void	STDECL	exchdir	    (const char *path);		// 室  ⠫.

// =========================================================================
//	४஢.
// =========================================================================
char*   dos2url		(char *psz);	// DOS->URL
char*   url2dos		(char *psz);	// URL->DOS
char*   dos2win		(char *psz);	// DOS->WIN
char*   win2dos		(char *psz);	// WIN->DOS
char*   DOS2WIN		(char *psz);	// DOS->WIN (32-bit console mode)
char*   WIN2DOS		(char *psz);	// WIN->DOS (32-bit console mode)

#ifdef __cplusplus
}
#endif

#ifdef	_CONSOLE__
#define DOS2WIN(psz)	dos2win(psz)
#define WIN2DOS(psz)	win2dos(psz)
#else
#define DOS2WIN(psz)	(psz)
#define WIN2DOS(psz)	(psz)
#endif

#ifdef	__TURBOC__
#define	exfindclose(ff)
#endif

#endif
