/*	dbget.c

	ணࠬ 䥩  "᪮": ⥭ ⠡筮 䠩.

	(C) ..㫫, ..஢,   PAH, 1994 - 1999
	All Rights Reserved.
*/
#include <malloc.h>
#include <string.h>
#include <disco.h>
#include <exalloc.h>
#include <exhandle.h>
#include <exio.h>
#ifdef	__TURBOC__
#pragma option -G
#endif

int	VDECL	_dbget_mode;			//  .
// =========================================================================
//	㦥 㭪樨.
// =========================================================================
void	EXDECL	_dbtextcode (	// ॢ ⥪  .
	char	*psBuf,		// ᨢ ࠧ஬ DBTEXT_SIZE(len)  ⥪⮬
	size_t	len		//  len, 稭  DBTEXT_START(len).
	)
{
  register char	ES_*ps_read;	// ⥫ ⥭
  register size_t count = 1;	// ᫮ ⮢  ப.
  size_t nLines = 0;		// ᫮ ப
  size_t nItems = 1;		// ᫮ 

//dbget_mode &= 0x7F;		// 㫥 襣 .
  ESLOAD (psBuf); ps_read = (char ES_*) psBuf;
  (((DBGETP ES_*) ps_read)++)->nFlags = 0;
  *ps_read++	= 0;		//  ॢ ᨬ ','  \r 
  *ps_read++	= EXEOL;	//  0, । ᫮ ப  .
  ps_read [len]	= EXEOF;	//  ନ 楫  
  {				//  襭   ⥪;
    for (;; ps_read++)		// ४ 訡 믮 ப
    {				//  ਥ "ᯮ祭 ⥪".
      switch (*ps_read)		// ୮ ਬ 㭪樨  
      {				// ਢ  ⮬  १.
	  case EXCR:	*ps_read = 0;		//  ப.
	  case 0:	// 		// ᯮ祭 ⥪.
			if (*++ps_read == EXEOL)// ஢ઠ ॢ ப.
			{
			  if (nItems < count) nItems = count;
			  nLines++;		// ⠥ ப.
			  count = 1;		// ⠥  ப.
			  break;
			}
			--ps_read;		// ᯮ祭 ⥪.
	  case EXEOL:	// 		// ᯮ祭 ⥪.
			*ps_read = DBSEP;	// ᯮ祭 ⥪.
	  case DBSEP:	// 		// ⥫ ⮢.
			if (count == (size_t)_dbget_mode) break;
			*ps_read = 0;		// 騩  ப.
			count++;		// ⠥  ப.
			break;

	  case EXEOF:	goto endfor;		//  ⥪.

	  case DBLIM:	if (count == (size_t)_dbget_mode) break;
	    for (;; ps_read++)			//   窠.
	    {
	      char ch  = ps_read [1];
	      if (ch == EXEOF) goto endfor;	//  䠩.
	      if (ch == DBLIM)			//  .
	      {
		*ps_read++ = 0; *ps_read++ = EXCR;
		ch = *ps_read;  *ps_read-- = 0;
		if (ch == EXEOF) goto endfor;	//  䠩.
		break;				// 室  譨 横.
	      }
	      if (ch == EXCR || ch == EXEOL)	// ॢ ப.
		ch = 0;				// ᯮ祭 ⥪.
	      *ps_read = ch;
	      if (ch == 0) { count++; break; }	// ᯮ祭 ⥪.
	    }
      }
    }
  }
endfor:
  if (ps_read [-1] != EXEOL)
  {						// ப  襭.
    *ps_read++ = 0;
    *ps_read++ = EXEOL;
    if (nItems < count) nItems = count;
    nLines++;
  }
  *ps_read = EXEOF;
  ((DBGETP *) psBuf) -> nLines = nLines;
  ((DBGETP *) psBuf) -> nItems = nItems;
  _dbget_mode = 0;

  return;
}

char*	EXDECL	dbreadcode (		// 䥩 ⥪ -> .
	const char *pszFile		//  䠩.
	)				// 뤠 㪠⥫ .
{
  int	fd;				// ਯ 䠩.
  long	lFile;				//  䠩.
#define uFile ((size_t) lFile)		// size_t- 䠩.
  char	*psBuf = NULL;			// ⥫ .

  if ((fd = exopenbr (pszFile)) >= 0)
  {
    if ((lFile = exlsize (fd)) > (unsigned long)
				  DBTEXT_SIZE (EXCALCBLOCKSIZE_MAX))
    {
      exprinterror (szF21, szOPENFAIL, pszFile, szESIZE);
    }
    else if ((psBuf = (char *) malloc (DBCODE_SIZE (uFile))) == NULL)
    {
      exprinterror (szF21, szOPENFAIL, pszFile, szENOMEM);
    }
    else
    {
      _exread (fd, psBuf + DBTEXT_START (uFile), uFile);
      _dbtextcode (psBuf, uFile);
    }
    exclose (fd);
  }
  _dbget_mode = 0;			// 塞 ०.

  return (psBuf);
}

// =========================================================================
//	⨥ - ⨥.
// =========================================================================
DBGET	VDECL	_dbget;				//  ⥭.
static	struct	{				// ਩ .
	DBGETP	parm;
	char	code [3];
}	_dbget_failbuf = {{0, 0, 0}, {'\0',EXEOL,EXEOF}};

//   dbget_open:		dbget_opencode:
// psParm Ŀ       psBuf Ŀ         	psParm Ŀ       psBuf Ŀ
//	  Ŀ	       Ŀ
//	  rc1     	       rc0     
//	  	       
//	            	                 

char*	EXDECL	dbget_opencode	(	// 砫 ⥭ .
	char *psBuf			// ᨢ   (, NULL).
	)
{
  if (_dbget.psParm != NULL) exprintfail (szF1, szEMATCH);	//  .
  _dbget.psBuf  = (char *) (
  _dbget.psParm = (psBuf? (DBGETP *) psBuf: &_dbget_failbuf.parm)
  ) + sizeof (DBGETP);
  return (psBuf);
}

int	EXDECL	dbget_open (		// 砫 ⥭ 䠩.
	const char *pszFile		//  䠩.
	)				// 뤠 < 0  㤠.
{
  return (dbget_opencode (dbreadcode (pszFile))?
	 (_dbget.psParm->nFlags = 1, 0): -1);
}

void	EXDECL	dbget_close (void)	//  ⥭.
{
  if (_dbget.psParm == NULL) exprintfail (szF1, szEMATCH);	//   .
  else if (_dbget.psParm->nFlags != 0)
  {
    free (_dbget.psParm);
  }
  _dbget.psBuf = NULL; _dbget.psParm = NULL;
}

// =========================================================================
//	⥭.
// =========================================================================
int	EXDECL	dbgetl	(void)		// । ப, ᫨ .
{                     			// 뤠 1 ()  0 ().
#ifndef __NOLCAST__
  #define ps  ((char ES_*) EBX)
#else
  register char ES_* ps;
#endif
  ESLOAD (_dbget.psBuf); ps = (char ES_*) _dbget.psBuf;

  do ps++; while (*ps != EXEOL); ps++;	// do; while (*ps++ != EXEOL);
  if (*ps == EXEOF)
    { (char ES_*) _dbget.psBuf = (ps -= 2); return (0); }
  //ELSE
    { (char ES_*) _dbget.psBuf = ps;	    return (1); }
#ifndef __NOLCAST__
  #undef ps
#endif
}

estring	EXDECL	dbget	(void)		// ।  ப.
{                     			// 뤠 㪠⥫.
#ifndef __NOLCAST__
  #define ps  ((char ES_*) EBX)
  #define ps0 ((char ES_*) EAX)
#else
  register char ES_* ps;
  register char ES_* ps0;
#endif
  ESLOAD (_dbget.psBuf); ps = ps0 = (char ES_*) _dbget.psBuf;

  if (*ps) do ps++; while (*ps); ps++;	// while (*ps++);
  if (*ps == EXCR) ps += 2;
  if (*ps == EXEOL) ps--;
  (char ES_*) _dbget.psBuf = ps;

  return ((estring) ps0);
#ifndef __NOLCAST__
  #undef ps
  #undef ps0
#endif
}
