/*	exhandle.c

	᪨ ᮮ饭, ६  㭪樨.

	(C) ..஢,   PAH, 1992 - 1999
	All Rights Reserved.
*/
#include <fcntl.h>
#include <exhandle.h>

int	VDECL	_exfind;	//   ४  ⢮.

const   char	VDECL	szRDONLY   []="Reading";	// ⠥.
const	char	VDECL	szWRONLY   []="Writing";	// 襬.
const	char	VDECL	szRDWR     []="Updating";	// 塞.
const   char	VDECL	szOPENFAIL []="Can\'t open";	// 訡  ⨨.
const	char	VDECL	szEDFULL   []="Disk full";
const	char	VDECL	szENOENT   []="No such file or directory";
const	char	VDECL	szEACCES   []="Access denied";
const	char	VDECL	szEMFILE   []="Too many open files";
static	char	VDECL	szERROR__  []="Error\0\0";	// 訡__.

#if	defined	(__TINY__) || defined (__SMALL__) || defined (__MEDIUM__)
const	char	VDECL	szENOMEM   []="Out of memory";		// 64K
#elif	defined	(__DPMI16__) || defined (__DPMI32__)
const	char	VDECL	szENOMEM   []="Out of memory";		// DPMI
#elif	defined (__MSDOS__) && !defined (_Windows)
const	char	VDECL	szENOMEM   []="Out of memory";		// DOS
#else
const	char	VDECL	szENOMEM   []="Out of memory";		// Virtual
#endif

int	STDECL	exopen_handle	(	// 믮 ᫥ .
		int	fd,		// ਯ.
	const	char*	path,		//  䠩.
		int	access		//  .
	)				// 頥 ਯ  -1.
{
  return (excode_handle (fd, path,
	((access & (O_WRONLY | O_RDWR))?
	((access & O_WRONLY || errno == ENOENT)? szWRONLY: szRDWR): szRDONLY),
        szOPENFAIL));
}

int	STDECL	excode_handle	(	// ࠡ⪠ १ 樨.
		int	code,		//  (訡, ᫨ < 0).
	const	char*	path,		//  䠩.
	const	char*	pszSuccess,	// 饭  ᯥ.
	const	char*	pszFailure	// 饭  訡.
	)
{
  if (code >= 0)
  {
    if (exprint > 0) exprintinfo (szF2, pszSuccess, path);
  }
  else if (!_exfind || errno != ENOENT)
  {
    exprinterror (szF21, pszFailure, path, exstrerrno());
  }
  _exfind = 0;
  return (code);
}

void	STDECL	exprinterrno	(void)		// 饭  errno-訡.
{
  exprinterror (szF1, exstrerrno());
}

const	char*	STDECL	exstrerrno (void)	//  ᮮ饭  訡.
{
  switch (errno)
  {
    case ENOENT : return (szENOENT);
    case EACCES	:
    case EBADF	: return (szEACCES);
    case EMFILE	: return (szEMFILE);
    case ENOMEM	: return (szENOMEM);
  }
  szERROR__ [sizeof (szERROR__) - 3] = (char) (errno / 10 + '0');
  szERROR__ [sizeof (szERROR__) - 2] = (char) (errno % 10 + '0');

  return (szERROR__);
}
